/* This file is automatically generated by Lemon from input grammar
** source file "parser.y". */
/*
** 2000-05-29
**
** The author disclaims copyright to this source code.  In place of
** a legal notice, here is a blessing:
**
**    May you do good and not evil.
**    May you find forgiveness for yourself and forgive others.
**    May you share freely, never taking more than you give.
**
*************************************************************************
** Driver template for the LEMON parser generator.
**
** The "lemon" program processes an LALR(1) input grammar file, then uses
** this template to construct a parser.  The "lemon" program inserts text
** at each "%%" line.  Also, any "P-a-r-s-e" identifer prefix (without the
** interstitial "-" characters) contained in this template is changed into
** the value of the %name directive from the grammar.  Otherwise, the content
** of this template is copied straight through into the generate parser
** source file.
**
** The following is the concatenation of all %include directives from the
** input grammar file:
*/
/************ Begin %include sections from the grammar ************************/
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <assert.h>

#include "../parse.h"

// unescape a string (non null terminated) and return the new length (may be shorter than the original. This manipulates the string itself
static size_t unescapen(char *s, size_t sz) {

  char *dst = s;
  char *src = dst;
  char *end = s + sz;
  while (src < end) {
      // unescape
      if (*src == '\\' && src + 1 < end &&
         (ispunct(*(src+1)) || isspace(*(src+1)))) {
          ++src;
          continue;
      }
      *dst++ = *src++;
  }

  return (size_t)(dst - s);
}

#define NODENN_BOTH_VALID 0
#define NODENN_BOTH_INVALID -1
#define NODENN_ONE_NULL 1
// Returns:
// 0 if a && b
// -1 if !a && !b
// 1 if a ^ b (i.e. !(a&&b||!a||!b)). The result is stored in `out`
static int one_not_null(void *a, void *b, void *out) {
    if (a && b) {
        return NODENN_BOTH_VALID;
    } else if (a == NULL && b == NULL) {
        return NODENN_BOTH_INVALID;
    } if (a) {
        *(void **)out = a;
        return NODENN_ONE_NULL;
    } else {
        *(void **)out = b;
        return NODENN_ONE_NULL;
    }
}

static void setup_trace(QueryParseCtx *ctx) {
#ifdef PARSER_DEBUG
  void RSQueryParser_Trace(FILE*, char*);
  ctx->trace_log = fopen("/tmp/lemon_query.log", "w");
  RSQueryParser_Trace(ctx->trace_log, "tr: ");
#endif
}

static void reportSyntaxError(QueryError *status, QueryToken* tok, const char *msg) {
  if (tok->type == QT_TERM || tok->type == QT_TERM_CASE) {
    QueryError_SetErrorFmt(status, QUERY_ESYNTAX,
      "%s at offset %d near %.*s", msg, tok->pos, tok->len, tok->s);
  } else if (tok->type == QT_NUMERIC) {
    QueryError_SetErrorFmt(status, QUERY_ESYNTAX,
      "%s at offset %d near %f", msg, tok->pos, tok->numval);
  } else {
    QueryError_SetErrorFmt(status, QUERY_ESYNTAX, "%s at offset %d", msg, tok->pos);
  }
}

/**************** End of %include directives **********************************/
/* These constants specify the various numeric values for terminal symbols.
***************** Begin token definitions *************************************/
#ifndef LOWEST
#define LOWEST                          1
#define TEXTEXPR                        2
#define ORX                             3
#define OR                              4
#define MODIFIER                        5
#define RP                              6
#define RB                              7
#define RSQB                            8
#define TERM                            9
#define QUOTE                          10
#define LP                             11
#define LB                             12
#define LSQB                           13
#define TILDE                          14
#define MINUS                          15
#define AND                            16
#define ARROW                          17
#define COLON                          18
#define NUMBER                         19
#define SIZE                           20
#define STOPWORD                       21
#define STAR                           22
#define TAGLIST                        23
#define TERMLIST                       24
#define PREFIX                         25
#define SUFFIX                         26
#define CONTAINS                       27
#define PERCENT                        28
#define ATTRIBUTE                      29
#define VERBATIM                       30
#define WILDCARD                       31
#define AS_S                           32
#define AS_T                           33
#define SEMICOLON                      34
#endif
/**************** End token definitions ***************************************/

/* The next sections is a series of control #defines.
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used to store the integer codes
**                       that represent terminal and non-terminal symbols.
**                       "unsigned char" is used if there are fewer than
**                       256 symbols.  Larger types otherwise.
**    YYNOCODE           is a number of type YYCODETYPE that is not used for
**                       any terminal or nonterminal symbol.
**    YYFALLBACK         If defined, this indicates that one or more tokens
**                       (also known as: "terminal symbols") have fall-back
**                       values which should be used if the original symbol
**                       would not parse.  This permits keywords to sometimes
**                       be used as identifiers, for example.
**    YYACTIONTYPE       is the data type used for "action codes" - numbers
**                       that indicate what to do in response to the next
**                       token.
**    RSQueryParser_v2_TOKENTYPE     is the data type used for minor type for terminal
**                       symbols.  Background: A "minor type" is a semantic
**                       value associated with a terminal or non-terminal
**                       symbols.  For example, for an "ID" terminal symbol,
**                       the minor type might be the name of the identifier.
**                       Each non-terminal can have a different minor type.
**                       Terminal symbols all have the same minor type, though.
**                       This macros defines the minor type for terminal 
**                       symbols.
**    YYMINORTYPE        is the data type used for all minor types.
**                       This is typically a union of many types, one of
**                       which is RSQueryParser_v2_TOKENTYPE.  The entry in the union
**                       for terminal symbols is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.  If
**                       zero the stack is dynamically sized using realloc()
**    RSQueryParser_v2_ARG_SDECL     A static variable declaration for the %extra_argument
**    RSQueryParser_v2_ARG_PDECL     A parameter declaration for the %extra_argument
**    RSQueryParser_v2_ARG_PARAM     Code to pass %extra_argument as a subroutine parameter
**    RSQueryParser_v2_ARG_STORE     Code to store %extra_argument into yypParser
**    RSQueryParser_v2_ARG_FETCH     Code to extract %extra_argument from yypParser
**    RSQueryParser_v2_CTX_*         As RSQueryParser_v2_ARG_ except for %extra_context
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYNTOKEN           Number of terminal symbols
**    YY_MAX_SHIFT       Maximum value for shift actions
**    YY_MIN_SHIFTREDUCE Minimum value for shift-reduce actions
**    YY_MAX_SHIFTREDUCE Maximum value for shift-reduce actions
**    YY_ERROR_ACTION    The yy_action[] code for syntax error
**    YY_ACCEPT_ACTION   The yy_action[] code for accept
**    YY_NO_ACTION       The yy_action[] code for no-op
**    YY_MIN_REDUCE      Minimum value for reduce actions
**    YY_MAX_REDUCE      Maximum value for reduce actions
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/************* Begin control #defines *****************************************/
#define YYCODETYPE unsigned char
#define YYNOCODE 65
#define YYACTIONTYPE unsigned short int
#define RSQueryParser_v2_TOKENTYPE QueryToken
typedef union {
  int yyinit;
  RSQueryParser_v2_TOKENTYPE yy0;
  QueryParam * yy6;
  QueryNode * yy27;
  QueryAttribute * yy53;
  QueryAttribute yy55;
  SingleVectorQueryParam yy56;
  RangeNumber yy59;
  Vector* yy66;
  VectorQueryParams yy86;
} YYMINORTYPE;
#ifndef YYSTACKDEPTH
#define YYSTACKDEPTH 256
#endif
#define RSQueryParser_v2_ARG_SDECL  QueryParseCtx *ctx ;
#define RSQueryParser_v2_ARG_PDECL , QueryParseCtx *ctx 
#define RSQueryParser_v2_ARG_PARAM ,ctx 
#define RSQueryParser_v2_ARG_FETCH  QueryParseCtx *ctx =yypParser->ctx ;
#define RSQueryParser_v2_ARG_STORE yypParser->ctx =ctx ;
#define RSQueryParser_v2_CTX_SDECL
#define RSQueryParser_v2_CTX_PDECL
#define RSQueryParser_v2_CTX_PARAM
#define RSQueryParser_v2_CTX_FETCH
#define RSQueryParser_v2_CTX_STORE
#define YYFALLBACK 1
#define YYNSTATE             115
#define YYNRULE              103
#define YYNRULE_WITH_ACTION  99
#define YYNTOKEN             35
#define YY_MAX_SHIFT         114
#define YY_MIN_SHIFTREDUCE   185
#define YY_MAX_SHIFTREDUCE   287
#define YY_ERROR_ACTION      288
#define YY_ACCEPT_ACTION     289
#define YY_NO_ACTION         290
#define YY_MIN_REDUCE        291
#define YY_MAX_REDUCE        393
/************* End control #defines *******************************************/
#define YY_NLOOKAHEAD ((int)(sizeof(yy_lookahead)/sizeof(yy_lookahead[0])))

/* Define the yytestcase() macro to be a no-op if is not already defined
** otherwise.
**
** Applications can choose to define yytestcase() in the %include section
** to a macro that can assist in verifying code coverage.  For production
** code the yytestcase() macro should be turned off.  But it is useful
** for testing.
*/
#ifndef yytestcase
# define yytestcase(X)
#endif


/* Next are the tables used to determine what action to take based on the
** current state and lookahead token.  These tables are used to implement
** functions that take a state number and lookahead value and return an
** action integer.  
**
** Suppose the action integer is N.  Then the action is determined as
** follows
**
**   0 <= N <= YY_MAX_SHIFT             Shift N.  That is, push the lookahead
**                                      token onto the stack and goto state N.
**
**   N between YY_MIN_SHIFTREDUCE       Shift to an arbitrary state then
**     and YY_MAX_SHIFTREDUCE           reduce by rule N-YY_MIN_SHIFTREDUCE.
**
**   N == YY_ERROR_ACTION               A syntax error has occurred.
**
**   N == YY_ACCEPT_ACTION              The parser accepts its input.
**
**   N == YY_NO_ACTION                  No such action.  Denotes unused
**                                      slots in the yy_action[] table.
**
**   N between YY_MIN_REDUCE            Reduce by rule N-YY_MIN_REDUCE
**     and YY_MAX_REDUCE
**
** The action table is constructed as a single large table named yy_action[].
** Given state S and lookahead X, the action is computed as either:
**
**    (A)   N = yy_action[ yy_shift_ofst[S] + X ]
**    (B)   N = yy_default[S]
**
** The (A) formula is preferred.  The B formula is used instead if
** yy_lookahead[yy_shift_ofst[S]+X] is not equal to X.
**
** The formulas above are for computing the action when the lookahead is
** a terminal symbol.  If the lookahead is a non-terminal (as occurs after
** a reduce action) then the yy_reduce_ofst[] array is used in place of
** the yy_shift_ofst[] array.
**
** The following are the tables generated in this section:
**
**  yy_action[]        A single table containing all actions.
**  yy_lookahead[]     A table containing the lookahead for each entry in
**                     yy_action.  Used to detect hash collisions.
**  yy_shift_ofst[]    For each state, the offset into yy_action for
**                     shifting terminals.
**  yy_reduce_ofst[]   For each state, the offset into yy_action for
**                     shifting non-terminals after a reduce.
**  yy_default[]       Default action for each state.
**
*********** Begin parsing tables **********************************************/
#define YY_ACTTAB_COUNT (793)
static const YYACTIONTYPE yy_action[] = {
 /*     0 */   389,  372,   45,  104,   12,  236,  203,   47,  105,  274,
 /*    10 */    44,   15,  364,   58,   13,   14,  389,   92,   57,  275,
 /*    20 */   276,  218,   72,   93,  326,  226,  227,  228,   56,  277,
 /*    30 */   108,  229,   16,  236,  204,   68,  110,  274,   44,   15,
 /*    40 */   107,  106,   13,   14,  389,  112,  111,  275,  276,  218,
 /*    50 */   109,   46,  278,  226,  227,  228,   56,  277,  291,  229,
 /*    60 */   274,  279,   12,  236,   84,   43,  367,  274,   44,   15,
 /*    70 */   275,  276,   13,   14,  375,   77,  376,  275,  276,  218,
 /*    80 */   277,   63,  102,  226,  227,  228,   56,  277,  292,  229,
 /*    90 */    87,   43,   65,  236,   91,   43,   64,  274,   44,    1,
 /*   100 */   268,  267,   13,   14,  287,  286,  370,  275,  276,  218,
 /*   110 */   284,  210,  274,  226,  227,  228,   56,  277,  271,  229,
 /*   120 */    16,  236,  275,  276,  262,  274,   44,   15,  272,  273,
 /*   130 */    13,   14,  277,   75,  325,  275,  276,  218,   74,  389,
 /*   140 */   274,  226,  227,  228,   56,  277,   48,  229,   12,  236,
 /*   150 */   275,  276,  221,  274,   44,   15,  312,   78,   13,   14,
 /*   160 */   277,   92,  344,  275,  276,  218,  312,   82,  274,  226,
 /*   170 */   227,  228,   56,  277,  311,  229,   16,  236,  275,  276,
 /*   180 */    99,  274,   44,   15,  371,  343,   13,   14,  277,  112,
 /*   190 */    73,  275,  276,  218,  293,  363,   58,  226,  227,  228,
 /*   200 */    56,  277,   34,  229,  204,   54,   50,  274,   44,   33,
 /*   210 */   236,   88,   31,   32,   89,  112,  211,  275,  276,  218,
 /*   220 */    53,   52,  313,  226,  227,  228,   56,  277,  348,  229,
 /*   230 */   236,  349,   61,  361,  274,   44,    1,   80,  353,   13,
 /*   240 */    14,  354,   60,   74,  275,  276,  218,  284,   83,   67,
 /*   250 */   226,  227,  228,   56,  277,   42,  229,  236,  239,   66,
 /*   260 */    71,  274,   44,   15,  285,  362,   13,   14,   70,   92,
 /*   270 */    86,  275,  276,  218,   26,  263,   51,  226,  227,  228,
 /*   280 */    56,  277,   30,  229,  236,  360,   90,   53,  274,   44,
 /*   290 */    15,  274,  212,   13,   14,  253,  112,  233,  275,  276,
 /*   300 */   218,  275,  276,  221,  226,  227,  228,   56,  277,  234,
 /*   310 */   229,  277,   95,  379,  274,   44,   33,   40,   49,   31,
 /*   320 */    32,  235,   97,   98,  275,  276,  218,  232,  100,  101,
 /*   330 */   226,  227,  228,   56,  277,   34,  229,  231,  103,  230,
 /*   340 */   274,   44,   33,  378,  377,   31,   32,  214,  112,  213,
 /*   350 */   275,  276,  218,   69,   54,   35,  226,  227,  228,   56,
 /*   360 */   277,   17,  229,  236,  290,  290,  290,  274,   44,   15,
 /*   370 */   290,  290,   13,   14,  290,  290,  290,  275,  276,  218,
 /*   380 */   290,  290,  290,  226,  227,  228,   56,  277,  290,  229,
 /*   390 */   290,  290,  290,  274,   44,   33,  290,  290,   31,   32,
 /*   400 */   290,  112,  290,  275,  276,  218,  290,  290,  290,  226,
 /*   410 */   227,  228,   56,  277,  290,  229,  290,  290,  290,  274,
 /*   420 */    44,   33,  290,  290,   31,   32,  290,  290,  290,  275,
 /*   430 */   276,  218,  290,  290,  290,  226,  227,  228,   56,  277,
 /*   440 */     4,  229,  290,  322,  290,  290,  323,  290,  114,  113,
 /*   450 */     5,   65,  290,  290,  290,   64,  290,  290,   79,  268,
 /*   460 */   267,  289,   76,   81,  321,    2,  290,  290,  322,  281,
 /*   470 */   290,  323,  290,  114,  113,    3,  290,  290,  290,  290,
 /*   480 */   290,  290,   92,   79,  275,  276,  218,   85,   81,  321,
 /*   490 */   226,  227,  228,   56,  277,  282,  229,   59,  290,  290,
 /*   500 */   112,   64,  275,  276,  218,  268,  267,  290,  226,  227,
 /*   510 */   228,   56,  277,  290,  229,  280,  290,  290,  290,   22,
 /*   520 */   290,  290,  322,  290,  290,  323,  290,  114,  113,   25,
 /*   530 */    23,  290,  290,  322,  290,  290,  323,   79,  114,  113,
 /*   540 */    24,  290,   81,  321,  290,  290,  290,  290,   79,  290,
 /*   550 */   290,  290,  290,   81,  321,    9,  290,  290,  322,  290,
 /*   560 */   290,  323,  290,  114,  113,   10,   19,  290,  290,  322,
 /*   570 */   290,  290,  323,   79,  114,  113,   20,  290,   81,  321,
 /*   580 */   290,  290,  290,  290,   79,  290,  290,  290,  290,   81,
 /*   590 */   321,   18,  290,  290,  322,  290,  290,  323,  290,  114,
 /*   600 */   113,   21,    2,  290,  290,  322,  290,  290,  323,   79,
 /*   610 */   114,  113,    3,  290,   81,  321,  290,  290,  290,  290,
 /*   620 */    79,  290,  290,  290,  290,   81,  321,    8,  290,  290,
 /*   630 */   322,  290,  290,  323,  290,  114,  113,   11,    6,  290,
 /*   640 */   290,  322,  290,  290,  323,   79,  114,  113,    7,  290,
 /*   650 */    81,  321,  290,  290,  290,  290,   79,  275,  276,  218,
 /*   660 */   274,   81,  321,  226,  227,  228,   56,  277,  290,  229,
 /*   670 */   275,  276,  241,  274,  290,  290,  226,  227,  228,  290,
 /*   680 */   277,  290,  229,  275,  276,  246,  290,  290,  290,  226,
 /*   690 */   227,  228,  290,  277,  290,  229,  322,  290,  290,  323,
 /*   700 */   290,  290,  113,   41,  251,  282,  358,   59,  290,  274,
 /*   710 */   290,   64,  274,  356,  290,  268,  267,  321,  290,  275,
 /*   720 */   276,   96,  275,  276,   94,  280,  290,  290,   62,  277,
 /*   730 */   322,   55,  277,  323,  290,  322,  113,   38,  323,  290,
 /*   740 */   290,  113,   39,  322,  290,  290,  323,  290,  290,  113,
 /*   750 */    36,  321,  322,  290,  322,  323,  321,  323,  113,   37,
 /*   760 */   113,   27,  322,  290,  321,  323,  290,  290,  113,   29,
 /*   770 */   290,  322,  290,  321,  323,  321,  290,  113,   28,  290,
 /*   780 */   290,  290,  290,  321,  290,  290,  290,  290,  290,  290,
 /*   790 */   290,  290,  321,
};
static const YYCODETYPE yy_lookahead[] = {
 /*     0 */    54,   51,   52,   59,    4,    5,    6,   61,   59,    9,
 /*    10 */    10,   11,   62,   63,   14,   15,   54,   17,   42,   19,
 /*    20 */    20,   21,    9,   61,   59,   25,   26,   27,   28,   29,
 /*    30 */     9,   31,    4,    5,    6,   59,   60,    9,   10,   11,
 /*    40 */    19,   20,   14,   15,   54,   17,   29,   19,   20,   21,
 /*    50 */    29,   61,   20,   25,   26,   27,   28,   29,    0,   31,
 /*    60 */     9,   29,    4,    5,   49,   50,   59,    9,   10,   11,
 /*    70 */    19,   20,   14,   15,   54,   17,   54,   19,   20,   21,
 /*    80 */    29,    9,   59,   25,   26,   27,   28,   29,    0,   31,
 /*    90 */    49,   50,   11,    5,   49,   50,   15,    9,   10,   11,
 /*   100 */    19,   20,   14,   15,   32,   33,   59,   19,   20,   21,
 /*   110 */    22,    7,    9,   25,   26,   27,   28,   29,    9,   31,
 /*   120 */     4,    5,   19,   20,   21,    9,   10,   11,   19,   20,
 /*   130 */    14,   15,   29,   17,   59,   19,   20,   21,   34,   54,
 /*   140 */     9,   25,   26,   27,   28,   29,   61,   31,    4,    5,
 /*   150 */    19,   20,   21,    9,   10,   11,   36,   37,   14,   15,
 /*   160 */    29,   17,   60,   19,   20,   21,   36,   37,    9,   25,
 /*   170 */    26,   27,   28,   29,   59,   31,    4,    5,   19,   20,
 /*   180 */    21,    9,   10,   11,   51,   60,   14,   15,   29,   17,
 /*   190 */    64,   19,   20,   21,    0,   62,   63,   25,   26,   27,
 /*   200 */    28,   29,    4,   31,    6,   12,   13,    9,   10,   11,
 /*   210 */     5,   17,   14,   15,   58,   17,    7,   19,   20,   21,
 /*   220 */    12,   13,   36,   25,   26,   27,   28,   29,   38,   31,
 /*   230 */     5,   41,   42,    0,    9,   10,   11,   47,   38,   14,
 /*   240 */    15,   41,   42,   34,   19,   20,   21,   22,    8,   59,
 /*   250 */    25,   26,   27,   28,   29,    4,   31,    5,    7,   59,
 /*   260 */     4,    9,   10,   11,    6,    0,   14,   15,    4,   17,
 /*   270 */     8,   19,   20,   21,   18,   29,   13,   25,   26,   27,
 /*   280 */    28,   29,   18,   31,    5,    0,    8,   12,    9,   10,
 /*   290 */    11,    9,   10,   14,   15,    8,   17,   28,   19,   20,
 /*   300 */    21,   19,   20,   21,   25,   26,   27,   28,   29,   28,
 /*   310 */    31,   29,   28,   10,    9,   10,   11,   12,   13,   14,
 /*   320 */    15,   28,   28,   28,   19,   20,   21,   28,   28,   28,
 /*   330 */    25,   26,   27,   28,   29,    4,   31,   28,   28,   28,
 /*   340 */     9,   10,   11,   10,   10,   14,   15,   10,   17,   10,
 /*   350 */    19,   20,   21,   18,   12,    4,   25,   26,   27,   28,
 /*   360 */    29,    4,   31,    5,   65,   65,   65,    9,   10,   11,
 /*   370 */    65,   65,   14,   15,   65,   65,   65,   19,   20,   21,
 /*   380 */    65,   65,   65,   25,   26,   27,   28,   29,   65,   31,
 /*   390 */    65,   65,   65,    9,   10,   11,   65,   65,   14,   15,
 /*   400 */    65,   17,   65,   19,   20,   21,   65,   65,   65,   25,
 /*   410 */    26,   27,   28,   29,   65,   31,   65,   65,   65,    9,
 /*   420 */    10,   11,   65,   65,   14,   15,   65,   65,   65,   19,
 /*   430 */    20,   21,   65,   65,   65,   25,   26,   27,   28,   29,
 /*   440 */    35,   31,   65,   38,   65,   65,   41,   65,   43,   44,
 /*   450 */    45,   11,   65,   65,   65,   15,   65,   65,   53,   19,
 /*   460 */    20,   56,   57,   58,   59,   35,   65,   65,   38,   29,
 /*   470 */    65,   41,   65,   43,   44,   45,   65,   65,   65,   65,
 /*   480 */    65,   65,   17,   53,   19,   20,   21,   57,   58,   59,
 /*   490 */    25,   26,   27,   28,   29,    9,   31,   11,   65,   65,
 /*   500 */    17,   15,   19,   20,   21,   19,   20,   65,   25,   26,
 /*   510 */    27,   28,   29,   65,   31,   29,   65,   65,   65,   35,
 /*   520 */    65,   65,   38,   65,   65,   41,   65,   43,   44,   45,
 /*   530 */    35,   65,   65,   38,   65,   65,   41,   53,   43,   44,
 /*   540 */    45,   65,   58,   59,   65,   65,   65,   65,   53,   65,
 /*   550 */    65,   65,   65,   58,   59,   35,   65,   65,   38,   65,
 /*   560 */    65,   41,   65,   43,   44,   45,   35,   65,   65,   38,
 /*   570 */    65,   65,   41,   53,   43,   44,   45,   65,   58,   59,
 /*   580 */    65,   65,   65,   65,   53,   65,   65,   65,   65,   58,
 /*   590 */    59,   35,   65,   65,   38,   65,   65,   41,   65,   43,
 /*   600 */    44,   45,   35,   65,   65,   38,   65,   65,   41,   53,
 /*   610 */    43,   44,   45,   65,   58,   59,   65,   65,   65,   65,
 /*   620 */    53,   65,   65,   65,   65,   58,   59,   35,   65,   65,
 /*   630 */    38,   65,   65,   41,   65,   43,   44,   45,   35,   65,
 /*   640 */    65,   38,   65,   65,   41,   53,   43,   44,   45,   65,
 /*   650 */    58,   59,   65,   65,   65,   65,   53,   19,   20,   21,
 /*   660 */     9,   58,   59,   25,   26,   27,   28,   29,   65,   31,
 /*   670 */    19,   20,   21,    9,   65,   65,   25,   26,   27,   65,
 /*   680 */    29,   65,   31,   19,   20,   21,   65,   65,   65,   25,
 /*   690 */    26,   27,   65,   29,   65,   31,   38,   65,   65,   41,
 /*   700 */    65,   65,   44,   45,    8,    9,   48,   11,   65,    9,
 /*   710 */    65,   15,    9,   55,   65,   19,   20,   59,   65,   19,
 /*   720 */    20,   21,   19,   20,   21,   29,   65,   65,   28,   29,
 /*   730 */    38,   28,   29,   41,   65,   38,   44,   45,   41,   65,
 /*   740 */    65,   44,   45,   38,   65,   65,   41,   65,   65,   44,
 /*   750 */    45,   59,   38,   65,   38,   41,   59,   41,   44,   45,
 /*   760 */    44,   45,   38,   65,   59,   41,   65,   65,   44,   45,
 /*   770 */    65,   38,   65,   59,   41,   59,   65,   44,   45,   65,
 /*   780 */    65,   65,   65,   59,   65,   65,   65,   65,   65,   65,
 /*   790 */    65,   65,   59,   35,   35,   35,   35,   35,   35,   35,
 /*   800 */    35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
 /*   810 */    35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
 /*   820 */    35,   35,   35,   35,   35,   35,   35,   35,
};
#define YY_SHIFT_COUNT    (114)
#define YY_SHIFT_MIN      (0)
#define YY_SHIFT_MAX      (703)
static const unsigned short int yy_shift_ofst[] = {
 /*     0 */    88,  225,    0,   28,   58,  116,  144,  172,  252,  252,
 /*    10 */   279,  279,  358,  358,  358,  358,  358,  358,  465,  465,
 /*    20 */   483,  483,  465,  465,  483,  483,  305,  198,  331,  384,
 /*    30 */   410,  410,  410,  410,  410,  410,  483,  483,  483,  638,
 /*    40 */   651,  638,  664,   72,   21,   72,  696,  486,  486,  486,
 /*    50 */    13,   13,   13,   17,   17,  700,  703,  282,  103,  440,
 /*    60 */   131,  131,  159,   51,   81,   81,   51,   51,   51,   51,
 /*    70 */   109,  109,   32,  205,   17,  193,  194,  208,  104,  264,
 /*    80 */   251,  256,  209,  233,  240,  258,  265,  262,  263,  246,
 /*    90 */   285,  278,  275,  287,  269,  281,  284,  293,  294,  295,
 /*   100 */   299,  300,  301,  309,  310,  311,  303,  333,  334,  337,
 /*   110 */   339,  335,  342,  351,  357,
};
#define YY_REDUCE_COUNT (74)
#define YY_REDUCE_MIN   (-56)
#define YY_REDUCE_MAX   (733)
static const short yy_reduce_ofst[] = {
 /*     0 */   405,  430,  484,  495,  484,  495,  484,  495,  484,  484,
 /*    10 */   495,  495,  520,  531,  556,  567,  592,  603,  484,  484,
 /*    20 */   495,  495,  484,  484,  495,  495,  658,  692,  692,  692,
 /*    30 */   697,  705,  714,  716,  724,  733,  692,  692,  692,  692,
 /*    40 */   190,  692,  200,  -50,  -24,  133,  -54,  -38,  -10,   85,
 /*    50 */    15,   41,   45,  120,  130,  -56,  -51,  -35,    7,   20,
 /*    60 */   -35,  -35,   23,   47,   22,   20,   75,   75,   75,  115,
 /*    70 */   102,  125,  126,  156,  186,
};
static const YYACTIONTYPE yy_default[] = {
 /*     0 */   288,  288,  288,  288,  288,  294,  301,  294,  302,  300,
 /*    10 */   303,  305,  288,  288,  288,  288,  288,  288,  328,  330,
 /*    20 */   331,  329,  295,  296,  298,  297,  288,  288,  306,  305,
 /*    30 */   288,  288,  288,  288,  288,  288,  331,  329,  298,  308,
 /*    40 */   288,  307,  288,  366,  288,  365,  288,  288,  288,  288,
 /*    50 */   288,  288,  288,  315,  315,  288,  288,  288,  288,  288,
 /*    60 */   355,  350,  288,  288,  288,  288,  351,  346,  288,  288,
 /*    70 */   288,  288,  288,  288,  314,  288,  288,  288,  288,  288,
 /*    80 */   288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
 /*    90 */   288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
 /*   100 */   288,  288,  288,  288,  288,  288,  382,  381,  380,  383,
 /*   110 */   288,  288,  288,  304,  299,
};
/********** End of lemon-generated parsing tables *****************************/

/* The next table maps tokens (terminal symbols) into fallback tokens.  
** If a construct like the following:
** 
**      %fallback ID X Y Z.
**
** appears in the grammar, then ID becomes a fallback token for X, Y,
** and Z.  Whenever one of the tokens X, Y, or Z is input to the parser
** but it does not parse, the type of the token is changed to ID and
** the parse is retried before an error is thrown.
**
** This feature can be used, for example, to cause some keywords in a language
** to revert to identifiers if they keyword does not apply in the context where
** it appears.
*/
#ifdef YYFALLBACK
static const YYCODETYPE yyFallback[] = {
    0,  /*          $ => nothing */
    0,  /*     LOWEST => nothing */
    0,  /*   TEXTEXPR => nothing */
    0,  /*        ORX => nothing */
    0,  /*         OR => nothing */
    0,  /*   MODIFIER => nothing */
    0,  /*         RP => nothing */
    0,  /*         RB => nothing */
    0,  /*       RSQB => nothing */
    0,  /*       TERM => nothing */
    0,  /*      QUOTE => nothing */
    0,  /*         LP => nothing */
    0,  /*         LB => nothing */
    0,  /*       LSQB => nothing */
    0,  /*      TILDE => nothing */
    0,  /*      MINUS => nothing */
    0,  /*        AND => nothing */
    0,  /*      ARROW => nothing */
    0,  /*      COLON => nothing */
    0,  /*     NUMBER => nothing */
    0,  /*       SIZE => nothing */
    0,  /*   STOPWORD => nothing */
    0,  /*       STAR => nothing */
    0,  /*    TAGLIST => nothing */
    0,  /*   TERMLIST => nothing */
    0,  /*     PREFIX => nothing */
    0,  /*     SUFFIX => nothing */
    0,  /*   CONTAINS => nothing */
    0,  /*    PERCENT => nothing */
    0,  /*  ATTRIBUTE => nothing */
    0,  /*   VERBATIM => nothing */
    0,  /*   WILDCARD => nothing */
   21,  /*       AS_S => STOPWORD */
    9,  /*       AS_T => TERM */
    0,  /*  SEMICOLON => nothing */
};
#endif /* YYFALLBACK */

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
**
** After the "shift" half of a SHIFTREDUCE action, the stateno field
** actually contains the reduce action for the second half of the
** SHIFTREDUCE.
*/
struct yyStackEntry {
  YYACTIONTYPE stateno;  /* The state-number, or reduce action in SHIFTREDUCE */
  YYCODETYPE major;      /* The major token value.  This is the code
                         ** number for the token at this stack level */
  YYMINORTYPE minor;     /* The user-supplied minor token value.  This
                         ** is the value of the token  */
};
typedef struct yyStackEntry yyStackEntry;

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  yyStackEntry *yytos;          /* Pointer to top element of the stack */
#ifdef YYTRACKMAXSTACKDEPTH
  int yyhwm;                    /* High-water mark of the stack */
#endif
#ifndef YYNOERRORRECOVERY
  int yyerrcnt;                 /* Shifts left before out of the error */
#endif
  RSQueryParser_v2_ARG_SDECL                /* A place to hold %extra_argument */
  RSQueryParser_v2_CTX_SDECL                /* A place to hold %extra_context */
#if YYSTACKDEPTH<=0
  int yystksz;                  /* Current side of the stack */
  yyStackEntry *yystack;        /* The parser's stack */
  yyStackEntry yystk0;          /* First stack entry */
#else
  yyStackEntry yystack[YYSTACKDEPTH];  /* The parser's stack */
  yyStackEntry *yystackEnd;            /* Last entry in the stack */
#endif
};
typedef struct yyParser yyParser;

#include <assert.h>
#ifndef NDEBUG
#include <stdio.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;
#endif /* NDEBUG */

#ifndef NDEBUG
/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void RSQueryParser_v2_Trace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}
#endif /* NDEBUG */

#if defined(YYCOVERAGE) || !defined(NDEBUG)
/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static const char *const yyTokenName[] = { 
  /*    0 */ "$",
  /*    1 */ "LOWEST",
  /*    2 */ "TEXTEXPR",
  /*    3 */ "ORX",
  /*    4 */ "OR",
  /*    5 */ "MODIFIER",
  /*    6 */ "RP",
  /*    7 */ "RB",
  /*    8 */ "RSQB",
  /*    9 */ "TERM",
  /*   10 */ "QUOTE",
  /*   11 */ "LP",
  /*   12 */ "LB",
  /*   13 */ "LSQB",
  /*   14 */ "TILDE",
  /*   15 */ "MINUS",
  /*   16 */ "AND",
  /*   17 */ "ARROW",
  /*   18 */ "COLON",
  /*   19 */ "NUMBER",
  /*   20 */ "SIZE",
  /*   21 */ "STOPWORD",
  /*   22 */ "STAR",
  /*   23 */ "TAGLIST",
  /*   24 */ "TERMLIST",
  /*   25 */ "PREFIX",
  /*   26 */ "SUFFIX",
  /*   27 */ "CONTAINS",
  /*   28 */ "PERCENT",
  /*   29 */ "ATTRIBUTE",
  /*   30 */ "VERBATIM",
  /*   31 */ "WILDCARD",
  /*   32 */ "AS_S",
  /*   33 */ "AS_T",
  /*   34 */ "SEMICOLON",
  /*   35 */ "expr",
  /*   36 */ "attribute",
  /*   37 */ "attribute_list",
  /*   38 */ "affix",
  /*   39 */ "suffix",
  /*   40 */ "contains",
  /*   41 */ "verbatim",
  /*   42 */ "termlist",
  /*   43 */ "union",
  /*   44 */ "text_union",
  /*   45 */ "text_expr",
  /*   46 */ "fuzzy",
  /*   47 */ "tag_list",
  /*   48 */ "geo_filter",
  /*   49 */ "vector_query",
  /*   50 */ "vector_command",
  /*   51 */ "vector_attribute",
  /*   52 */ "vector_attribute_list",
  /*   53 */ "modifierlist",
  /*   54 */ "num",
  /*   55 */ "numeric_range",
  /*   56 */ "query",
  /*   57 */ "star",
  /*   58 */ "modifier",
  /*   59 */ "param_term",
  /*   60 */ "term",
  /*   61 */ "param_any",
  /*   62 */ "vector_score_field",
  /*   63 */ "as",
  /*   64 */ "param_size",
};
#endif /* defined(YYCOVERAGE) || !defined(NDEBUG) */

#ifndef NDEBUG
/* For tracing reduce actions, the names of all rules are required.
*/
static const char *const yyRuleName[] = {
 /*   0 */ "query ::= expr",
 /*   1 */ "query ::=",
 /*   2 */ "query ::= star",
 /*   3 */ "expr ::= text_expr",
 /*   4 */ "expr ::= expr expr",
 /*   5 */ "expr ::= text_expr expr",
 /*   6 */ "expr ::= expr text_expr",
 /*   7 */ "text_expr ::= text_expr text_expr",
 /*   8 */ "expr ::= union",
 /*   9 */ "union ::= expr OR expr",
 /*  10 */ "union ::= union OR expr",
 /*  11 */ "union ::= text_expr OR expr",
 /*  12 */ "union ::= expr OR text_expr",
 /*  13 */ "text_expr ::= text_union",
 /*  14 */ "text_union ::= text_expr OR text_expr",
 /*  15 */ "text_union ::= text_union OR text_expr",
 /*  16 */ "expr ::= modifier COLON text_expr",
 /*  17 */ "expr ::= modifierlist COLON text_expr",
 /*  18 */ "expr ::= LP expr RP",
 /*  19 */ "text_expr ::= LP text_expr RP",
 /*  20 */ "attribute ::= ATTRIBUTE COLON param_term",
 /*  21 */ "attribute_list ::= attribute",
 /*  22 */ "attribute_list ::= attribute_list SEMICOLON attribute",
 /*  23 */ "attribute_list ::= attribute_list SEMICOLON",
 /*  24 */ "attribute_list ::=",
 /*  25 */ "expr ::= expr ARROW LB attribute_list RB",
 /*  26 */ "text_expr ::= text_expr ARROW LB attribute_list RB",
 /*  27 */ "text_expr ::= QUOTE termlist QUOTE",
 /*  28 */ "text_expr ::= QUOTE term QUOTE",
 /*  29 */ "text_expr ::= QUOTE ATTRIBUTE QUOTE",
 /*  30 */ "text_expr ::= param_term",
 /*  31 */ "text_expr ::= affix",
 /*  32 */ "text_expr ::= verbatim",
 /*  33 */ "text_expr ::= STOPWORD",
 /*  34 */ "termlist ::= param_term param_term",
 /*  35 */ "termlist ::= termlist param_term",
 /*  36 */ "termlist ::= termlist STOPWORD",
 /*  37 */ "expr ::= MINUS expr",
 /*  38 */ "text_expr ::= MINUS text_expr",
 /*  39 */ "expr ::= TILDE expr",
 /*  40 */ "text_expr ::= TILDE text_expr",
 /*  41 */ "affix ::= PREFIX",
 /*  42 */ "affix ::= SUFFIX",
 /*  43 */ "affix ::= CONTAINS",
 /*  44 */ "verbatim ::= WILDCARD",
 /*  45 */ "text_expr ::= PERCENT param_term PERCENT",
 /*  46 */ "text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT",
 /*  47 */ "text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT",
 /*  48 */ "text_expr ::= PERCENT STOPWORD PERCENT",
 /*  49 */ "text_expr ::= PERCENT PERCENT STOPWORD PERCENT PERCENT",
 /*  50 */ "text_expr ::= PERCENT PERCENT PERCENT STOPWORD PERCENT PERCENT PERCENT",
 /*  51 */ "modifier ::= MODIFIER",
 /*  52 */ "modifierlist ::= modifier OR term",
 /*  53 */ "modifierlist ::= modifierlist OR term",
 /*  54 */ "expr ::= modifier COLON LB tag_list RB",
 /*  55 */ "tag_list ::= param_term",
 /*  56 */ "tag_list ::= STOPWORD",
 /*  57 */ "tag_list ::= affix",
 /*  58 */ "tag_list ::= verbatim",
 /*  59 */ "tag_list ::= termlist",
 /*  60 */ "tag_list ::= tag_list OR param_term",
 /*  61 */ "tag_list ::= tag_list OR STOPWORD",
 /*  62 */ "tag_list ::= tag_list OR affix",
 /*  63 */ "tag_list ::= tag_list OR verbatim",
 /*  64 */ "tag_list ::= tag_list OR termlist",
 /*  65 */ "expr ::= modifier COLON numeric_range",
 /*  66 */ "numeric_range ::= LSQB param_any param_any RSQB",
 /*  67 */ "expr ::= modifier COLON geo_filter",
 /*  68 */ "geo_filter ::= LSQB param_any param_any param_any param_any RSQB",
 /*  69 */ "query ::= expr ARROW LSQB vector_query RSQB",
 /*  70 */ "query ::= text_expr ARROW LSQB vector_query RSQB",
 /*  71 */ "query ::= star ARROW LSQB vector_query RSQB",
 /*  72 */ "vector_query ::= vector_command vector_attribute_list vector_score_field",
 /*  73 */ "vector_query ::= vector_command vector_score_field",
 /*  74 */ "vector_query ::= vector_command vector_attribute_list",
 /*  75 */ "vector_query ::= vector_command",
 /*  76 */ "vector_score_field ::= as param_term",
 /*  77 */ "vector_score_field ::= as STOPWORD",
 /*  78 */ "vector_command ::= TERM param_size modifier ATTRIBUTE",
 /*  79 */ "vector_attribute ::= TERM param_term",
 /*  80 */ "vector_attribute_list ::= vector_attribute_list vector_attribute",
 /*  81 */ "vector_attribute_list ::= vector_attribute",
 /*  82 */ "num ::= SIZE",
 /*  83 */ "num ::= NUMBER",
 /*  84 */ "num ::= LP num",
 /*  85 */ "num ::= MINUS num",
 /*  86 */ "term ::= TERM",
 /*  87 */ "term ::= NUMBER",
 /*  88 */ "term ::= SIZE",
 /*  89 */ "param_term ::= TERM",
 /*  90 */ "param_term ::= NUMBER",
 /*  91 */ "param_term ::= SIZE",
 /*  92 */ "param_term ::= ATTRIBUTE",
 /*  93 */ "param_size ::= SIZE",
 /*  94 */ "param_size ::= ATTRIBUTE",
 /*  95 */ "param_any ::= ATTRIBUTE",
 /*  96 */ "param_any ::= LP ATTRIBUTE",
 /*  97 */ "param_any ::= TERM",
 /*  98 */ "param_any ::= num",
 /*  99 */ "star ::= STAR",
 /* 100 */ "star ::= LP star RP",
 /* 101 */ "as ::= AS_T",
 /* 102 */ "as ::= AS_S",
};
#endif /* NDEBUG */


#if YYSTACKDEPTH<=0
/*
** Try to increase the size of the parser stack.  Return the number
** of errors.  Return 0 on success.
*/
static int yyGrowStack(yyParser *p){
  int newSize;
  int idx;
  yyStackEntry *pNew;

  newSize = p->yystksz*2 + 100;
  idx = p->yytos ? (int)(p->yytos - p->yystack) : 0;
  if( p->yystack==&p->yystk0 ){
    pNew = malloc(newSize*sizeof(pNew[0]));
    if( pNew ) pNew[0] = p->yystk0;
  }else{
    pNew = realloc(p->yystack, newSize*sizeof(pNew[0]));
  }
  if( pNew ){
    p->yystack = pNew;
    p->yytos = &p->yystack[idx];
#ifndef NDEBUG
    if( yyTraceFILE ){
      fprintf(yyTraceFILE,"%sStack grows from %d to %d entries.\n",
              yyTracePrompt, p->yystksz, newSize);
    }
#endif
    p->yystksz = newSize;
  }
  return pNew==0; 
}
#endif

/* Datatype of the argument to the memory allocated passed as the
** second argument to RSQueryParser_v2_Alloc() below.  This can be changed by
** putting an appropriate #define in the %include section of the input
** grammar.
*/
#ifndef YYMALLOCARGTYPE
# define YYMALLOCARGTYPE size_t
#endif

/* Initialize a new parser that has already been allocated.
*/
void RSQueryParser_v2_Init(void *yypRawParser RSQueryParser_v2_CTX_PDECL){
  yyParser *yypParser = (yyParser*)yypRawParser;
  RSQueryParser_v2_CTX_STORE
#ifdef YYTRACKMAXSTACKDEPTH
  yypParser->yyhwm = 0;
#endif
#if YYSTACKDEPTH<=0
  yypParser->yytos = NULL;
  yypParser->yystack = NULL;
  yypParser->yystksz = 0;
  if( yyGrowStack(yypParser) ){
    yypParser->yystack = &yypParser->yystk0;
    yypParser->yystksz = 1;
  }
#endif
#ifndef YYNOERRORRECOVERY
  yypParser->yyerrcnt = -1;
#endif
  yypParser->yytos = yypParser->yystack;
  yypParser->yystack[0].stateno = 0;
  yypParser->yystack[0].major = 0;
#if YYSTACKDEPTH>0
  yypParser->yystackEnd = &yypParser->yystack[YYSTACKDEPTH-1];
#endif
}

#ifndef RSQueryParser_v2__ENGINEALWAYSONSTACK
/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to RSQueryParser_v2_ and RSQueryParser_v2_Free.
*/
void *RSQueryParser_v2_Alloc(void *(*mallocProc)(YYMALLOCARGTYPE) RSQueryParser_v2_CTX_PDECL){
  yyParser *yypParser;
  yypParser = (yyParser*)(*mallocProc)( (YYMALLOCARGTYPE)sizeof(yyParser) );
  if( yypParser ){
    RSQueryParser_v2_CTX_STORE
    RSQueryParser_v2_Init(yypParser RSQueryParser_v2_CTX_PARAM);
  }
  return (void*)yypParser;
}
#endif /* RSQueryParser_v2__ENGINEALWAYSONSTACK */


/* The following function deletes the "minor type" or semantic value
** associated with a symbol.  The symbol can be either a terminal
** or nonterminal. "yymajor" is the symbol code, and "yypminor" is
** a pointer to the value to be deleted.  The code used to do the 
** deletions is derived from the %destructor and/or %token_destructor
** directives of the input grammar.
*/
static void yy_destructor(
  yyParser *yypParser,    /* The parser */
  YYCODETYPE yymajor,     /* Type code for object to destroy */
  YYMINORTYPE *yypminor   /* The object to be destroyed */
){
  RSQueryParser_v2_ARG_FETCH
  RSQueryParser_v2_CTX_FETCH
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are *not* used
    ** inside the C code.
    */
/********* Begin destructor definitions ***************************************/
      /* Default NON-TERMINAL Destructor */
    case 51: /* vector_attribute */
    case 54: /* num */
    case 56: /* query */
    case 57: /* star */
    case 58: /* modifier */
    case 59: /* param_term */
    case 60: /* term */
    case 61: /* param_any */
    case 62: /* vector_score_field */
    case 63: /* as */
    case 64: /* param_size */
{
 
}
      break;
    case 35: /* expr */
    case 38: /* affix */
    case 39: /* suffix */
    case 40: /* contains */
    case 41: /* verbatim */
    case 42: /* termlist */
    case 43: /* union */
    case 44: /* text_union */
    case 45: /* text_expr */
    case 46: /* fuzzy */
    case 47: /* tag_list */
    case 49: /* vector_query */
    case 50: /* vector_command */
{
 QueryNode_Free((yypminor->yy27)); 
}
      break;
    case 36: /* attribute */
{
 rm_free((char*)(yypminor->yy55).value); 
}
      break;
    case 37: /* attribute_list */
{
 array_free_ex((yypminor->yy53), rm_free((char*)((QueryAttribute*)ptr )->value)); 
}
      break;
    case 48: /* geo_filter */
{
 QueryParam_Free((yypminor->yy6)); 
}
      break;
    case 52: /* vector_attribute_list */
{

  array_free((yypminor->yy86).needResolve);
  array_free_ex((yypminor->yy86).params, {
    rm_free((char*)((VecSimRawParam*)ptr)->value);
    rm_free((char*)((VecSimRawParam*)ptr)->name);
  });

}
      break;
    case 53: /* modifierlist */
{

    for (size_t i = 0; i < Vector_Size((yypminor->yy66)); i++) {
        char *s;
        Vector_Get((yypminor->yy66), i, &s);
        rm_free(s);
    }
    Vector_Free((yypminor->yy66));

}
      break;
    case 55: /* numeric_range */
{

  QueryParam_Free((yypminor->yy6));

}
      break;
/********* End destructor definitions *****************************************/
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
*/
static void yy_pop_parser_stack(yyParser *pParser){
  yyStackEntry *yytos;
  assert( pParser->yytos!=0 );
  assert( pParser->yytos > pParser->yystack );
  yytos = pParser->yytos--;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[yytos->major]);
  }
#endif
  yy_destructor(pParser, yytos->major, &yytos->minor);
}

/*
** Clear all secondary memory allocations from the parser
*/
void RSQueryParser_v2_Finalize(void *p){
  yyParser *pParser = (yyParser*)p;
  while( pParser->yytos>pParser->yystack ) yy_pop_parser_stack(pParser);
#if YYSTACKDEPTH<=0
  if( pParser->yystack!=&pParser->yystk0 ) free(pParser->yystack);
#endif
}

#ifndef RSQueryParser_v2__ENGINEALWAYSONSTACK
/* 
** Deallocate and destroy a parser.  Destructors are called for
** all stack elements before shutting the parser down.
**
** If the YYPARSEFREENEVERNULL macro exists (for example because it
** is defined in a %include section of the input grammar) then it is
** assumed that the input pointer is never NULL.
*/
void RSQueryParser_v2_Free(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
#ifndef YYPARSEFREENEVERNULL
  if( p==0 ) return;
#endif
  RSQueryParser_v2_Finalize(p);
  (*freeProc)(p);
}
#endif /* RSQueryParser_v2__ENGINEALWAYSONSTACK */

/*
** Return the peak depth of the stack for a parser.
*/
#ifdef YYTRACKMAXSTACKDEPTH
int RSQueryParser_v2_StackPeak(void *p){
  yyParser *pParser = (yyParser*)p;
  return pParser->yyhwm;
}
#endif

/* This array of booleans keeps track of the parser statement
** coverage.  The element yycoverage[X][Y] is set when the parser
** is in state X and has a lookahead token Y.  In a well-tested
** systems, every element of this matrix should end up being set.
*/
#if defined(YYCOVERAGE)
static unsigned char yycoverage[YYNSTATE][YYNTOKEN];
#endif

/*
** Write into out a description of every state/lookahead combination that
**
**   (1)  has not been used by the parser, and
**   (2)  is not a syntax error.
**
** Return the number of missed state/lookahead combinations.
*/
#if defined(YYCOVERAGE)
int RSQueryParser_v2_Coverage(FILE *out){
  int stateno, iLookAhead, i;
  int nMissed = 0;
  for(stateno=0; stateno<YYNSTATE; stateno++){
    i = yy_shift_ofst[stateno];
    for(iLookAhead=0; iLookAhead<YYNTOKEN; iLookAhead++){
      if( yy_lookahead[i+iLookAhead]!=iLookAhead ) continue;
      if( yycoverage[stateno][iLookAhead]==0 ) nMissed++;
      if( out ){
        fprintf(out,"State %d lookahead %s %s\n", stateno,
                yyTokenName[iLookAhead],
                yycoverage[stateno][iLookAhead] ? "ok" : "missed");
      }
    }
  }
  return nMissed;
}
#endif

/*
** Find the appropriate action for a parser given the terminal
** look-ahead token iLookAhead.
*/
static YYACTIONTYPE yy_find_shift_action(
  YYCODETYPE iLookAhead,    /* The look-ahead token */
  YYACTIONTYPE stateno      /* Current state number */
){
  int i;

  if( stateno>YY_MAX_SHIFT ) return stateno;
  assert( stateno <= YY_SHIFT_COUNT );
#if defined(YYCOVERAGE)
  yycoverage[stateno][iLookAhead] = 1;
#endif
  do{
    i = yy_shift_ofst[stateno];
    assert( i>=0 );
    assert( i<=YY_ACTTAB_COUNT );
    assert( i+YYNTOKEN<=(int)YY_NLOOKAHEAD );
    assert( iLookAhead!=YYNOCODE );
    assert( iLookAhead < YYNTOKEN );
    i += iLookAhead;
    assert( i<(int)YY_NLOOKAHEAD );
    if( yy_lookahead[i]!=iLookAhead ){
#ifdef YYFALLBACK
      YYCODETYPE iFallback;            /* Fallback token */
      assert( iLookAhead<sizeof(yyFallback)/sizeof(yyFallback[0]) );
      iFallback = yyFallback[iLookAhead];
      if( iFallback!=0 ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE, "%sFALLBACK %s => %s\n",
             yyTracePrompt, yyTokenName[iLookAhead], yyTokenName[iFallback]);
        }
#endif
        assert( yyFallback[iFallback]==0 ); /* Fallback loop must terminate */
        iLookAhead = iFallback;
        continue;
      }
#endif
#ifdef YYWILDCARD
      {
        int j = i - iLookAhead + YYWILDCARD;
        assert( j<(int)(sizeof(yy_lookahead)/sizeof(yy_lookahead[0])) );
        if( yy_lookahead[j]==YYWILDCARD && iLookAhead>0 ){
#ifndef NDEBUG
          if( yyTraceFILE ){
            fprintf(yyTraceFILE, "%sWILDCARD %s => %s\n",
               yyTracePrompt, yyTokenName[iLookAhead],
               yyTokenName[YYWILDCARD]);
          }
#endif /* NDEBUG */
          return yy_action[j];
        }
      }
#endif /* YYWILDCARD */
      return yy_default[stateno];
    }else{
      assert( i>=0 && i<(int)(sizeof(yy_action)/sizeof(yy_action[0])) );
      return yy_action[i];
    }
  }while(1);
}

/*
** Find the appropriate action for a parser given the non-terminal
** look-ahead token iLookAhead.
*/
static YYACTIONTYPE yy_find_reduce_action(
  YYACTIONTYPE stateno,     /* Current state number */
  YYCODETYPE iLookAhead     /* The look-ahead token */
){
  int i;
#ifdef YYERRORSYMBOL
  if( stateno>YY_REDUCE_COUNT ){
    return yy_default[stateno];
  }
#else
  assert( stateno<=YY_REDUCE_COUNT );
#endif
  i = yy_reduce_ofst[stateno];
  assert( iLookAhead!=YYNOCODE );
  i += iLookAhead;
#ifdef YYERRORSYMBOL
  if( i<0 || i>=YY_ACTTAB_COUNT || yy_lookahead[i]!=iLookAhead ){
    return yy_default[stateno];
  }
#else
  assert( i>=0 && i<YY_ACTTAB_COUNT );
  assert( yy_lookahead[i]==iLookAhead );
#endif
  return yy_action[i];
}

/*
** The following routine is called if the stack overflows.
*/
static void yyStackOverflow(yyParser *yypParser){
   RSQueryParser_v2_ARG_FETCH
   RSQueryParser_v2_CTX_FETCH
#ifndef NDEBUG
   if( yyTraceFILE ){
     fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
   }
#endif
   while( yypParser->yytos>yypParser->yystack ) yy_pop_parser_stack(yypParser);
   /* Here code is inserted which will execute if the parser
   ** stack every overflows */
/******** Begin %stack_overflow code ******************************************/

  QueryError_SetErrorFmt(ctx->status, QUERY_ESYNTAX,
    "Parser stack overflow. Try moving nested parentheses more to the left");
/******** End %stack_overflow code ********************************************/
   RSQueryParser_v2_ARG_STORE /* Suppress warning about unused %extra_argument var */
   RSQueryParser_v2_CTX_STORE
}

/*
** Print tracing information for a SHIFT action
*/
#ifndef NDEBUG
static void yyTraceShift(yyParser *yypParser, int yyNewState, const char *zTag){
  if( yyTraceFILE ){
    if( yyNewState<YYNSTATE ){
      fprintf(yyTraceFILE,"%s%s '%s', go to state %d\n",
         yyTracePrompt, zTag, yyTokenName[yypParser->yytos->major],
         yyNewState);
    }else{
      fprintf(yyTraceFILE,"%s%s '%s', pending reduce %d\n",
         yyTracePrompt, zTag, yyTokenName[yypParser->yytos->major],
         yyNewState - YY_MIN_REDUCE);
    }
  }
}
#else
# define yyTraceShift(X,Y,Z)
#endif

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  YYACTIONTYPE yyNewState,      /* The new state to shift in */
  YYCODETYPE yyMajor,           /* The major token to shift in */
  RSQueryParser_v2_TOKENTYPE yyMinor        /* The minor token to shift in */
){
  yyStackEntry *yytos;
  yypParser->yytos++;
#ifdef YYTRACKMAXSTACKDEPTH
  if( (int)(yypParser->yytos - yypParser->yystack)>yypParser->yyhwm ){
    yypParser->yyhwm++;
    assert( yypParser->yyhwm == (int)(yypParser->yytos - yypParser->yystack) );
  }
#endif
#if YYSTACKDEPTH>0 
  if( yypParser->yytos>yypParser->yystackEnd ){
    yypParser->yytos--;
    yyStackOverflow(yypParser);
    return;
  }
#else
  if( yypParser->yytos>=&yypParser->yystack[yypParser->yystksz] ){
    if( yyGrowStack(yypParser) ){
      yypParser->yytos--;
      yyStackOverflow(yypParser);
      return;
    }
  }
#endif
  if( yyNewState > YY_MAX_SHIFT ){
    yyNewState += YY_MIN_REDUCE - YY_MIN_SHIFTREDUCE;
  }
  yytos = yypParser->yytos;
  yytos->stateno = yyNewState;
  yytos->major = yyMajor;
  yytos->minor.yy0 = yyMinor;
  yyTraceShift(yypParser, yyNewState, "Shift");
}

/* For rule J, yyRuleInfoLhs[J] contains the symbol on the left-hand side
** of that rule */
static const YYCODETYPE yyRuleInfoLhs[] = {
    56,  /* (0) query ::= expr */
    56,  /* (1) query ::= */
    56,  /* (2) query ::= star */
    35,  /* (3) expr ::= text_expr */
    35,  /* (4) expr ::= expr expr */
    35,  /* (5) expr ::= text_expr expr */
    35,  /* (6) expr ::= expr text_expr */
    45,  /* (7) text_expr ::= text_expr text_expr */
    35,  /* (8) expr ::= union */
    43,  /* (9) union ::= expr OR expr */
    43,  /* (10) union ::= union OR expr */
    43,  /* (11) union ::= text_expr OR expr */
    43,  /* (12) union ::= expr OR text_expr */
    45,  /* (13) text_expr ::= text_union */
    44,  /* (14) text_union ::= text_expr OR text_expr */
    44,  /* (15) text_union ::= text_union OR text_expr */
    35,  /* (16) expr ::= modifier COLON text_expr */
    35,  /* (17) expr ::= modifierlist COLON text_expr */
    35,  /* (18) expr ::= LP expr RP */
    45,  /* (19) text_expr ::= LP text_expr RP */
    36,  /* (20) attribute ::= ATTRIBUTE COLON param_term */
    37,  /* (21) attribute_list ::= attribute */
    37,  /* (22) attribute_list ::= attribute_list SEMICOLON attribute */
    37,  /* (23) attribute_list ::= attribute_list SEMICOLON */
    37,  /* (24) attribute_list ::= */
    35,  /* (25) expr ::= expr ARROW LB attribute_list RB */
    45,  /* (26) text_expr ::= text_expr ARROW LB attribute_list RB */
    45,  /* (27) text_expr ::= QUOTE termlist QUOTE */
    45,  /* (28) text_expr ::= QUOTE term QUOTE */
    45,  /* (29) text_expr ::= QUOTE ATTRIBUTE QUOTE */
    45,  /* (30) text_expr ::= param_term */
    45,  /* (31) text_expr ::= affix */
    45,  /* (32) text_expr ::= verbatim */
    45,  /* (33) text_expr ::= STOPWORD */
    42,  /* (34) termlist ::= param_term param_term */
    42,  /* (35) termlist ::= termlist param_term */
    42,  /* (36) termlist ::= termlist STOPWORD */
    35,  /* (37) expr ::= MINUS expr */
    45,  /* (38) text_expr ::= MINUS text_expr */
    35,  /* (39) expr ::= TILDE expr */
    45,  /* (40) text_expr ::= TILDE text_expr */
    38,  /* (41) affix ::= PREFIX */
    38,  /* (42) affix ::= SUFFIX */
    38,  /* (43) affix ::= CONTAINS */
    41,  /* (44) verbatim ::= WILDCARD */
    45,  /* (45) text_expr ::= PERCENT param_term PERCENT */
    45,  /* (46) text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT */
    45,  /* (47) text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT */
    45,  /* (48) text_expr ::= PERCENT STOPWORD PERCENT */
    45,  /* (49) text_expr ::= PERCENT PERCENT STOPWORD PERCENT PERCENT */
    45,  /* (50) text_expr ::= PERCENT PERCENT PERCENT STOPWORD PERCENT PERCENT PERCENT */
    58,  /* (51) modifier ::= MODIFIER */
    53,  /* (52) modifierlist ::= modifier OR term */
    53,  /* (53) modifierlist ::= modifierlist OR term */
    35,  /* (54) expr ::= modifier COLON LB tag_list RB */
    47,  /* (55) tag_list ::= param_term */
    47,  /* (56) tag_list ::= STOPWORD */
    47,  /* (57) tag_list ::= affix */
    47,  /* (58) tag_list ::= verbatim */
    47,  /* (59) tag_list ::= termlist */
    47,  /* (60) tag_list ::= tag_list OR param_term */
    47,  /* (61) tag_list ::= tag_list OR STOPWORD */
    47,  /* (62) tag_list ::= tag_list OR affix */
    47,  /* (63) tag_list ::= tag_list OR verbatim */
    47,  /* (64) tag_list ::= tag_list OR termlist */
    35,  /* (65) expr ::= modifier COLON numeric_range */
    55,  /* (66) numeric_range ::= LSQB param_any param_any RSQB */
    35,  /* (67) expr ::= modifier COLON geo_filter */
    48,  /* (68) geo_filter ::= LSQB param_any param_any param_any param_any RSQB */
    56,  /* (69) query ::= expr ARROW LSQB vector_query RSQB */
    56,  /* (70) query ::= text_expr ARROW LSQB vector_query RSQB */
    56,  /* (71) query ::= star ARROW LSQB vector_query RSQB */
    49,  /* (72) vector_query ::= vector_command vector_attribute_list vector_score_field */
    49,  /* (73) vector_query ::= vector_command vector_score_field */
    49,  /* (74) vector_query ::= vector_command vector_attribute_list */
    49,  /* (75) vector_query ::= vector_command */
    62,  /* (76) vector_score_field ::= as param_term */
    62,  /* (77) vector_score_field ::= as STOPWORD */
    50,  /* (78) vector_command ::= TERM param_size modifier ATTRIBUTE */
    51,  /* (79) vector_attribute ::= TERM param_term */
    52,  /* (80) vector_attribute_list ::= vector_attribute_list vector_attribute */
    52,  /* (81) vector_attribute_list ::= vector_attribute */
    54,  /* (82) num ::= SIZE */
    54,  /* (83) num ::= NUMBER */
    54,  /* (84) num ::= LP num */
    54,  /* (85) num ::= MINUS num */
    60,  /* (86) term ::= TERM */
    60,  /* (87) term ::= NUMBER */
    60,  /* (88) term ::= SIZE */
    59,  /* (89) param_term ::= TERM */
    59,  /* (90) param_term ::= NUMBER */
    59,  /* (91) param_term ::= SIZE */
    59,  /* (92) param_term ::= ATTRIBUTE */
    64,  /* (93) param_size ::= SIZE */
    64,  /* (94) param_size ::= ATTRIBUTE */
    61,  /* (95) param_any ::= ATTRIBUTE */
    61,  /* (96) param_any ::= LP ATTRIBUTE */
    61,  /* (97) param_any ::= TERM */
    61,  /* (98) param_any ::= num */
    57,  /* (99) star ::= STAR */
    57,  /* (100) star ::= LP star RP */
    63,  /* (101) as ::= AS_T */
    63,  /* (102) as ::= AS_S */
};

/* For rule J, yyRuleInfoNRhs[J] contains the negative of the number
** of symbols on the right-hand side of that rule. */
static const signed char yyRuleInfoNRhs[] = {
   -1,  /* (0) query ::= expr */
    0,  /* (1) query ::= */
   -1,  /* (2) query ::= star */
   -1,  /* (3) expr ::= text_expr */
   -2,  /* (4) expr ::= expr expr */
   -2,  /* (5) expr ::= text_expr expr */
   -2,  /* (6) expr ::= expr text_expr */
   -2,  /* (7) text_expr ::= text_expr text_expr */
   -1,  /* (8) expr ::= union */
   -3,  /* (9) union ::= expr OR expr */
   -3,  /* (10) union ::= union OR expr */
   -3,  /* (11) union ::= text_expr OR expr */
   -3,  /* (12) union ::= expr OR text_expr */
   -1,  /* (13) text_expr ::= text_union */
   -3,  /* (14) text_union ::= text_expr OR text_expr */
   -3,  /* (15) text_union ::= text_union OR text_expr */
   -3,  /* (16) expr ::= modifier COLON text_expr */
   -3,  /* (17) expr ::= modifierlist COLON text_expr */
   -3,  /* (18) expr ::= LP expr RP */
   -3,  /* (19) text_expr ::= LP text_expr RP */
   -3,  /* (20) attribute ::= ATTRIBUTE COLON param_term */
   -1,  /* (21) attribute_list ::= attribute */
   -3,  /* (22) attribute_list ::= attribute_list SEMICOLON attribute */
   -2,  /* (23) attribute_list ::= attribute_list SEMICOLON */
    0,  /* (24) attribute_list ::= */
   -5,  /* (25) expr ::= expr ARROW LB attribute_list RB */
   -5,  /* (26) text_expr ::= text_expr ARROW LB attribute_list RB */
   -3,  /* (27) text_expr ::= QUOTE termlist QUOTE */
   -3,  /* (28) text_expr ::= QUOTE term QUOTE */
   -3,  /* (29) text_expr ::= QUOTE ATTRIBUTE QUOTE */
   -1,  /* (30) text_expr ::= param_term */
   -1,  /* (31) text_expr ::= affix */
   -1,  /* (32) text_expr ::= verbatim */
   -1,  /* (33) text_expr ::= STOPWORD */
   -2,  /* (34) termlist ::= param_term param_term */
   -2,  /* (35) termlist ::= termlist param_term */
   -2,  /* (36) termlist ::= termlist STOPWORD */
   -2,  /* (37) expr ::= MINUS expr */
   -2,  /* (38) text_expr ::= MINUS text_expr */
   -2,  /* (39) expr ::= TILDE expr */
   -2,  /* (40) text_expr ::= TILDE text_expr */
   -1,  /* (41) affix ::= PREFIX */
   -1,  /* (42) affix ::= SUFFIX */
   -1,  /* (43) affix ::= CONTAINS */
   -1,  /* (44) verbatim ::= WILDCARD */
   -3,  /* (45) text_expr ::= PERCENT param_term PERCENT */
   -5,  /* (46) text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT */
   -7,  /* (47) text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT */
   -3,  /* (48) text_expr ::= PERCENT STOPWORD PERCENT */
   -5,  /* (49) text_expr ::= PERCENT PERCENT STOPWORD PERCENT PERCENT */
   -7,  /* (50) text_expr ::= PERCENT PERCENT PERCENT STOPWORD PERCENT PERCENT PERCENT */
   -1,  /* (51) modifier ::= MODIFIER */
   -3,  /* (52) modifierlist ::= modifier OR term */
   -3,  /* (53) modifierlist ::= modifierlist OR term */
   -5,  /* (54) expr ::= modifier COLON LB tag_list RB */
   -1,  /* (55) tag_list ::= param_term */
   -1,  /* (56) tag_list ::= STOPWORD */
   -1,  /* (57) tag_list ::= affix */
   -1,  /* (58) tag_list ::= verbatim */
   -1,  /* (59) tag_list ::= termlist */
   -3,  /* (60) tag_list ::= tag_list OR param_term */
   -3,  /* (61) tag_list ::= tag_list OR STOPWORD */
   -3,  /* (62) tag_list ::= tag_list OR affix */
   -3,  /* (63) tag_list ::= tag_list OR verbatim */
   -3,  /* (64) tag_list ::= tag_list OR termlist */
   -3,  /* (65) expr ::= modifier COLON numeric_range */
   -4,  /* (66) numeric_range ::= LSQB param_any param_any RSQB */
   -3,  /* (67) expr ::= modifier COLON geo_filter */
   -6,  /* (68) geo_filter ::= LSQB param_any param_any param_any param_any RSQB */
   -5,  /* (69) query ::= expr ARROW LSQB vector_query RSQB */
   -5,  /* (70) query ::= text_expr ARROW LSQB vector_query RSQB */
   -5,  /* (71) query ::= star ARROW LSQB vector_query RSQB */
   -3,  /* (72) vector_query ::= vector_command vector_attribute_list vector_score_field */
   -2,  /* (73) vector_query ::= vector_command vector_score_field */
   -2,  /* (74) vector_query ::= vector_command vector_attribute_list */
   -1,  /* (75) vector_query ::= vector_command */
   -2,  /* (76) vector_score_field ::= as param_term */
   -2,  /* (77) vector_score_field ::= as STOPWORD */
   -4,  /* (78) vector_command ::= TERM param_size modifier ATTRIBUTE */
   -2,  /* (79) vector_attribute ::= TERM param_term */
   -2,  /* (80) vector_attribute_list ::= vector_attribute_list vector_attribute */
   -1,  /* (81) vector_attribute_list ::= vector_attribute */
   -1,  /* (82) num ::= SIZE */
   -1,  /* (83) num ::= NUMBER */
   -2,  /* (84) num ::= LP num */
   -2,  /* (85) num ::= MINUS num */
   -1,  /* (86) term ::= TERM */
   -1,  /* (87) term ::= NUMBER */
   -1,  /* (88) term ::= SIZE */
   -1,  /* (89) param_term ::= TERM */
   -1,  /* (90) param_term ::= NUMBER */
   -1,  /* (91) param_term ::= SIZE */
   -1,  /* (92) param_term ::= ATTRIBUTE */
   -1,  /* (93) param_size ::= SIZE */
   -1,  /* (94) param_size ::= ATTRIBUTE */
   -1,  /* (95) param_any ::= ATTRIBUTE */
   -2,  /* (96) param_any ::= LP ATTRIBUTE */
   -1,  /* (97) param_any ::= TERM */
   -1,  /* (98) param_any ::= num */
   -1,  /* (99) star ::= STAR */
   -3,  /* (100) star ::= LP star RP */
   -1,  /* (101) as ::= AS_T */
   -1,  /* (102) as ::= AS_S */
};

static void yy_accept(yyParser*);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
**
** The yyLookahead and yyLookaheadToken parameters provide reduce actions
** access to the lookahead token (if any).  The yyLookahead will be YYNOCODE
** if the lookahead token has already been consumed.  As this procedure is
** only called from one place, optimizing compilers will in-line it, which
** means that the extra parameters have no performance impact.
*/
static YYACTIONTYPE yy_reduce(
  yyParser *yypParser,         /* The parser */
  unsigned int yyruleno,       /* Number of the rule by which to reduce */
  int yyLookahead,             /* Lookahead token, or YYNOCODE if none */
  RSQueryParser_v2_TOKENTYPE yyLookaheadToken  /* Value of the lookahead token */
  RSQueryParser_v2_CTX_PDECL                   /* %extra_context */
){
  int yygoto;                     /* The next state */
  YYACTIONTYPE yyact;             /* The next action */
  yyStackEntry *yymsp;            /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  RSQueryParser_v2_ARG_FETCH
  (void)yyLookahead;
  (void)yyLookaheadToken;
  yymsp = yypParser->yytos;

  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
/********** Begin reduce actions **********************************************/
        YYMINORTYPE yylhsminor;
      case 0: /* query ::= expr */
{
  setup_trace(ctx);
  ctx->root = yymsp[0].minor.yy27;
}
        break;
      case 1: /* query ::= */
{
  ctx->root = NULL;
}
        break;
      case 2: /* query ::= star */
{  yy_destructor(yypParser,57,&yymsp[0].minor);
{
  setup_trace(ctx);
  ctx->root = NewWildcardNode();
}
}
        break;
      case 3: /* expr ::= text_expr */
      case 8: /* expr ::= union */ yytestcase(yyruleno==8);
      case 13: /* text_expr ::= text_union */ yytestcase(yyruleno==13);
      case 75: /* vector_query ::= vector_command */ yytestcase(yyruleno==75);
{
  yylhsminor.yy27 = yymsp[0].minor.yy27;
}
  yymsp[0].minor.yy27 = yylhsminor.yy27;
        break;
      case 4: /* expr ::= expr expr */
      case 5: /* expr ::= text_expr expr */ yytestcase(yyruleno==5);
      case 6: /* expr ::= expr text_expr */ yytestcase(yyruleno==6);
      case 7: /* text_expr ::= text_expr text_expr */ yytestcase(yyruleno==7);
{
    int rv = one_not_null(yymsp[-1].minor.yy27, yymsp[0].minor.yy27, (void**)&yylhsminor.yy27);
    if (rv == NODENN_BOTH_INVALID) {
        yylhsminor.yy27 = NULL;
    } else if (rv == NODENN_ONE_NULL) {
        // Nothing- `out` is already assigned
    } else {
        if (yymsp[-1].minor.yy27 && yymsp[-1].minor.yy27->type == QN_PHRASE && yymsp[-1].minor.yy27->pn.exact == 0 &&
            yymsp[-1].minor.yy27->opts.fieldMask == RS_FIELDMASK_ALL ) {
            yylhsminor.yy27 = yymsp[-1].minor.yy27;
        } else {
            yylhsminor.yy27 = NewPhraseNode(0);
            QueryNode_AddChild(yylhsminor.yy27, yymsp[-1].minor.yy27);
        }
        QueryNode_AddChild(yylhsminor.yy27, yymsp[0].minor.yy27);
    }
}
  yymsp[-1].minor.yy27 = yylhsminor.yy27;
        break;
      case 9: /* union ::= expr OR expr */
      case 11: /* union ::= text_expr OR expr */ yytestcase(yyruleno==11);
      case 12: /* union ::= expr OR text_expr */ yytestcase(yyruleno==12);
      case 14: /* text_union ::= text_expr OR text_expr */ yytestcase(yyruleno==14);
{
    int rv = one_not_null(yymsp[-2].minor.yy27, yymsp[0].minor.yy27, (void**)&yylhsminor.yy27);
    if (rv == NODENN_BOTH_INVALID) {
        yylhsminor.yy27 = NULL;
    } else if (rv == NODENN_ONE_NULL) {
        // Nothing- already assigned
    } else {
        if (yymsp[-2].minor.yy27->type == QN_UNION && yymsp[-2].minor.yy27->opts.fieldMask == RS_FIELDMASK_ALL) {
            yylhsminor.yy27 = yymsp[-2].minor.yy27;
        } else {
            yylhsminor.yy27 = NewUnionNode();
            QueryNode_AddChild(yylhsminor.yy27, yymsp[-2].minor.yy27);
            yylhsminor.yy27->opts.fieldMask |= yymsp[-2].minor.yy27->opts.fieldMask;
        }
        // Handle yymsp[0].minor.yy27
        QueryNode_AddChild(yylhsminor.yy27, yymsp[0].minor.yy27);
        yylhsminor.yy27->opts.fieldMask |= yymsp[0].minor.yy27->opts.fieldMask;
        QueryNode_SetFieldMask(yylhsminor.yy27, yylhsminor.yy27->opts.fieldMask);
    }
}
  yymsp[-2].minor.yy27 = yylhsminor.yy27;
        break;
      case 10: /* union ::= union OR expr */
      case 15: /* text_union ::= text_union OR text_expr */ yytestcase(yyruleno==15);
{
    yylhsminor.yy27 = yymsp[-2].minor.yy27;
    if (yymsp[0].minor.yy27) {
        QueryNode_AddChild(yylhsminor.yy27, yymsp[0].minor.yy27);
        yylhsminor.yy27->opts.fieldMask |= yymsp[0].minor.yy27->opts.fieldMask;
        QueryNode_SetFieldMask(yymsp[0].minor.yy27, yylhsminor.yy27->opts.fieldMask);
    }
}
  yymsp[-2].minor.yy27 = yylhsminor.yy27;
        break;
      case 16: /* expr ::= modifier COLON text_expr */
{
    if (yymsp[0].minor.yy27 == NULL) {
        yylhsminor.yy27 = NULL;
    } else {
        if (ctx->sctx->spec) {
            QueryNode_SetFieldMask(yymsp[0].minor.yy27, IndexSpec_GetFieldBit(ctx->sctx->spec, yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len));
        }
        yylhsminor.yy27 = yymsp[0].minor.yy27;
    }
}
  yymsp[-2].minor.yy27 = yylhsminor.yy27;
        break;
      case 17: /* expr ::= modifierlist COLON text_expr */
{

    if (yymsp[0].minor.yy27 == NULL) {
        for (size_t i = 0; i < Vector_Size(yymsp[-2].minor.yy66); i++) {
          char *s;
          Vector_Get(yymsp[-2].minor.yy66, i, &s);
          rm_free(s);
        }
        Vector_Free(yymsp[-2].minor.yy66);
        yylhsminor.yy27 = NULL;
    } else {
        //yymsp[0].minor.yy27->opts.fieldMask = 0;
        t_fieldMask mask = 0;
        for (int i = 0; i < Vector_Size(yymsp[-2].minor.yy66); i++) {
            char *p;
            Vector_Get(yymsp[-2].minor.yy66, i, &p);
            if (ctx->sctx->spec) {
              mask |= IndexSpec_GetFieldBit(ctx->sctx->spec, p, strlen(p));
            }
            rm_free(p);
        }
        Vector_Free(yymsp[-2].minor.yy66);
        QueryNode_SetFieldMask(yymsp[0].minor.yy27, mask);
        yylhsminor.yy27=yymsp[0].minor.yy27;
    }
}
  yymsp[-2].minor.yy27 = yylhsminor.yy27;
        break;
      case 18: /* expr ::= LP expr RP */
      case 19: /* text_expr ::= LP text_expr RP */ yytestcase(yyruleno==19);
{
  yymsp[-2].minor.yy27 = yymsp[-1].minor.yy27;
}
        break;
      case 20: /* attribute ::= ATTRIBUTE COLON param_term */
{
  const char *value = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
  size_t value_len = yymsp[0].minor.yy0.len;
  if (yymsp[0].minor.yy0.type == QT_PARAM_TERM) {
    size_t found_value_len;
    const char *found_value = Param_DictGet(ctx->opts->params, value, &found_value_len, ctx->status);
    if (found_value) {
      rm_free((char*)value);
      value = rm_strndup(found_value, found_value_len);
      value_len = found_value_len;
    }
  }
  yylhsminor.yy55 = (QueryAttribute){ .name = yymsp[-2].minor.yy0.s, .namelen = yymsp[-2].minor.yy0.len, .value = value, .vallen = value_len };
}
  yymsp[-2].minor.yy55 = yylhsminor.yy55;
        break;
      case 21: /* attribute_list ::= attribute */
{
  yylhsminor.yy53 = array_new(QueryAttribute, 2);
  yylhsminor.yy53 = array_append(yylhsminor.yy53, yymsp[0].minor.yy55);
}
  yymsp[0].minor.yy53 = yylhsminor.yy53;
        break;
      case 22: /* attribute_list ::= attribute_list SEMICOLON attribute */
{
  yylhsminor.yy53 = array_append(yymsp[-2].minor.yy53, yymsp[0].minor.yy55);
}
  yymsp[-2].minor.yy53 = yylhsminor.yy53;
        break;
      case 23: /* attribute_list ::= attribute_list SEMICOLON */
{
  yylhsminor.yy53 = yymsp[-1].minor.yy53;
}
  yymsp[-1].minor.yy53 = yylhsminor.yy53;
        break;
      case 24: /* attribute_list ::= */
{
  yymsp[1].minor.yy53 = NULL;
}
        break;
      case 25: /* expr ::= expr ARROW LB attribute_list RB */
      case 26: /* text_expr ::= text_expr ARROW LB attribute_list RB */ yytestcase(yyruleno==26);
{

    if (yymsp[-4].minor.yy27 && yymsp[-1].minor.yy53) {
        QueryNode_ApplyAttributes(yymsp[-4].minor.yy27, yymsp[-1].minor.yy53, array_len(yymsp[-1].minor.yy53), ctx->status);
    }
    array_free_ex(yymsp[-1].minor.yy53, rm_free((char*)((QueryAttribute*)ptr )->value));
    yylhsminor.yy27 = yymsp[-4].minor.yy27;
}
  yymsp[-4].minor.yy27 = yylhsminor.yy27;
        break;
      case 27: /* text_expr ::= QUOTE termlist QUOTE */
{
  // TODO: Quoted/verbatim string in termlist should not be handled as parameters
  // Also need to add the leading '$' which was consumed by the lexer
  yymsp[-1].minor.yy27->pn.exact = 1;
  yymsp[-1].minor.yy27->opts.flags |= QueryNode_Verbatim;

  yymsp[-2].minor.yy27 = yymsp[-1].minor.yy27;
}
        break;
      case 28: /* text_expr ::= QUOTE term QUOTE */
{
  yymsp[-2].minor.yy27 = NewTokenNode(ctx, rm_strdupcase(yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len), -1);
  yymsp[-2].minor.yy27->opts.flags |= QueryNode_Verbatim;
}
        break;
      case 29: /* text_expr ::= QUOTE ATTRIBUTE QUOTE */
{
  // Quoted/verbatim string should not be handled as parameters
  // Also need to add the leading '$' which was consumed by the lexer
  char *s = rm_malloc(yymsp[-1].minor.yy0.len + 1);
  *s = '$';
  memcpy(s + 1, yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len);
  yymsp[-2].minor.yy27 = NewTokenNode(ctx, rm_strdupcase(s, yymsp[-1].minor.yy0.len + 1), -1);
  rm_free(s);
  yymsp[-2].minor.yy27->opts.flags |= QueryNode_Verbatim;
}
        break;
      case 30: /* text_expr ::= param_term */
{
  yylhsminor.yy27 = NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0);
}
  yymsp[0].minor.yy27 = yylhsminor.yy27;
        break;
      case 31: /* text_expr ::= affix */
      case 32: /* text_expr ::= verbatim */ yytestcase(yyruleno==32);
{
yylhsminor.yy27 = yymsp[0].minor.yy27;
}
  yymsp[0].minor.yy27 = yylhsminor.yy27;
        break;
      case 33: /* text_expr ::= STOPWORD */
{
  yymsp[0].minor.yy27 = NULL;
}
        break;
      case 34: /* termlist ::= param_term param_term */
{
  yylhsminor.yy27 = NewPhraseNode(0);
  QueryNode_AddChild(yylhsminor.yy27, NewTokenNode_WithParams(ctx, &yymsp[-1].minor.yy0));
  QueryNode_AddChild(yylhsminor.yy27, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
}
  yymsp[-1].minor.yy27 = yylhsminor.yy27;
        break;
      case 35: /* termlist ::= termlist param_term */
{
  yylhsminor.yy27 = yymsp[-1].minor.yy27;
  QueryNode_AddChild(yylhsminor.yy27, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
}
  yymsp[-1].minor.yy27 = yylhsminor.yy27;
        break;
      case 36: /* termlist ::= termlist STOPWORD */
{
  yylhsminor.yy27 = yymsp[-1].minor.yy27;
}
  yymsp[-1].minor.yy27 = yylhsminor.yy27;
        break;
      case 37: /* expr ::= MINUS expr */
      case 38: /* text_expr ::= MINUS text_expr */ yytestcase(yyruleno==38);
{
    if (yymsp[0].minor.yy27) {
        yymsp[-1].minor.yy27 = NewNotNode(yymsp[0].minor.yy27);
    } else {
        yymsp[-1].minor.yy27 = NULL;
    }
}
        break;
      case 39: /* expr ::= TILDE expr */
      case 40: /* text_expr ::= TILDE text_expr */ yytestcase(yyruleno==40);
{
    if (yymsp[0].minor.yy27) {
        yymsp[-1].minor.yy27 = NewOptionalNode(yymsp[0].minor.yy27);
    } else {
        yymsp[-1].minor.yy27 = NULL;
    }
}
        break;
      case 41: /* affix ::= PREFIX */
{
    yylhsminor.yy27 = NewPrefixNode_WithParams(ctx, &yymsp[0].minor.yy0, true, false);
}
  yymsp[0].minor.yy27 = yylhsminor.yy27;
        break;
      case 42: /* affix ::= SUFFIX */
{
    yylhsminor.yy27 = NewPrefixNode_WithParams(ctx, &yymsp[0].minor.yy0, false, true);
}
  yymsp[0].minor.yy27 = yylhsminor.yy27;
        break;
      case 43: /* affix ::= CONTAINS */
{
    yylhsminor.yy27 = NewPrefixNode_WithParams(ctx, &yymsp[0].minor.yy0, true, true);
}
  yymsp[0].minor.yy27 = yylhsminor.yy27;
        break;
      case 44: /* verbatim ::= WILDCARD */
{
    yylhsminor.yy27 = NewWildcardNode_WithParams(ctx, &yymsp[0].minor.yy0);
}
  yymsp[0].minor.yy27 = yylhsminor.yy27;
        break;
      case 45: /* text_expr ::= PERCENT param_term PERCENT */
      case 48: /* text_expr ::= PERCENT STOPWORD PERCENT */ yytestcase(yyruleno==48);
{
  yymsp[-2].minor.yy27 = NewFuzzyNode_WithParams(ctx, &yymsp[-1].minor.yy0, 1);
}
        break;
      case 46: /* text_expr ::= PERCENT PERCENT param_term PERCENT PERCENT */
      case 49: /* text_expr ::= PERCENT PERCENT STOPWORD PERCENT PERCENT */ yytestcase(yyruleno==49);
{
  yymsp[-4].minor.yy27 = NewFuzzyNode_WithParams(ctx, &yymsp[-2].minor.yy0, 2);
}
        break;
      case 47: /* text_expr ::= PERCENT PERCENT PERCENT param_term PERCENT PERCENT PERCENT */
      case 50: /* text_expr ::= PERCENT PERCENT PERCENT STOPWORD PERCENT PERCENT PERCENT */ yytestcase(yyruleno==50);
{
  yymsp[-6].minor.yy27 = NewFuzzyNode_WithParams(ctx, &yymsp[-3].minor.yy0, 3);
}
        break;
      case 51: /* modifier ::= MODIFIER */
{
    yymsp[0].minor.yy0.len = unescapen((char*)yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
    yylhsminor.yy0 = yymsp[0].minor.yy0;
 }
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 52: /* modifierlist ::= modifier OR term */
{
    yylhsminor.yy66 = NewVector(char *, 2);
    char *s = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
    Vector_Push(yylhsminor.yy66, s);
    s = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
    Vector_Push(yylhsminor.yy66, s);
}
  yymsp[-2].minor.yy66 = yylhsminor.yy66;
        break;
      case 53: /* modifierlist ::= modifierlist OR term */
{
    char *s = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
    Vector_Push(yymsp[-2].minor.yy66, s);
    yylhsminor.yy66 = yymsp[-2].minor.yy66;
}
  yymsp[-2].minor.yy66 = yylhsminor.yy66;
        break;
      case 54: /* expr ::= modifier COLON LB tag_list RB */
{
    if (!yymsp[-1].minor.yy27) {
        yylhsminor.yy27 = NULL;
    } else {
      // Tag field names must be case sensitive, we can't do rm_strdupcase
        char *s = rm_strndup(yymsp[-4].minor.yy0.s, yymsp[-4].minor.yy0.len);
        size_t slen = unescapen((char*)s, yymsp[-4].minor.yy0.len);

        yylhsminor.yy27 = NewTagNode(s, slen);
        QueryNode_AddChildren(yylhsminor.yy27, yymsp[-1].minor.yy27->children, QueryNode_NumChildren(yymsp[-1].minor.yy27));

        // Set the children count on yymsp[-1].minor.yy27 to 0 so they won't get recursively free'd
        QueryNode_ClearChildren(yymsp[-1].minor.yy27, 0);
        QueryNode_Free(yymsp[-1].minor.yy27);
    }
}
  yymsp[-4].minor.yy27 = yylhsminor.yy27;
        break;
      case 55: /* tag_list ::= param_term */
{
  yylhsminor.yy27 = NewPhraseNode(0);
  if (yymsp[0].minor.yy0.type == QT_TERM)
    yymsp[0].minor.yy0.type = QT_TERM_CASE;
  else if (yymsp[0].minor.yy0.type == QT_PARAM_TERM)
    yymsp[0].minor.yy0.type = QT_PARAM_TERM_CASE;
  QueryNode_AddChild(yylhsminor.yy27, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
}
  yymsp[0].minor.yy27 = yylhsminor.yy27;
        break;
      case 56: /* tag_list ::= STOPWORD */
{
    yylhsminor.yy27 = NewPhraseNode(0);
    QueryNode_AddChild(yylhsminor.yy27, NewTokenNode(ctx, rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len), -1));
}
  yymsp[0].minor.yy27 = yylhsminor.yy27;
        break;
      case 57: /* tag_list ::= affix */
      case 58: /* tag_list ::= verbatim */ yytestcase(yyruleno==58);
      case 59: /* tag_list ::= termlist */ yytestcase(yyruleno==59);
{
    yylhsminor.yy27 = NewPhraseNode(0);
    QueryNode_AddChild(yylhsminor.yy27, yymsp[0].minor.yy27);
}
  yymsp[0].minor.yy27 = yylhsminor.yy27;
        break;
      case 60: /* tag_list ::= tag_list OR param_term */
{
  if (yymsp[0].minor.yy0.type == QT_TERM)
    yymsp[0].minor.yy0.type = QT_TERM_CASE;
  else if (yymsp[0].minor.yy0.type == QT_PARAM_TERM)
    yymsp[0].minor.yy0.type = QT_PARAM_TERM_CASE;
  QueryNode_AddChild(yymsp[-2].minor.yy27, NewTokenNode_WithParams(ctx, &yymsp[0].minor.yy0));
  yylhsminor.yy27 = yymsp[-2].minor.yy27;
}
  yymsp[-2].minor.yy27 = yylhsminor.yy27;
        break;
      case 61: /* tag_list ::= tag_list OR STOPWORD */
{
    QueryNode_AddChild(yymsp[-2].minor.yy27, NewTokenNode(ctx, rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len), -1));
    yylhsminor.yy27 = yymsp[-2].minor.yy27;
}
  yymsp[-2].minor.yy27 = yylhsminor.yy27;
        break;
      case 62: /* tag_list ::= tag_list OR affix */
      case 63: /* tag_list ::= tag_list OR verbatim */ yytestcase(yyruleno==63);
      case 64: /* tag_list ::= tag_list OR termlist */ yytestcase(yyruleno==64);
{
    QueryNode_AddChild(yymsp[-2].minor.yy27, yymsp[0].minor.yy27);
    yylhsminor.yy27 = yymsp[-2].minor.yy27;
}
  yymsp[-2].minor.yy27 = yylhsminor.yy27;
        break;
      case 65: /* expr ::= modifier COLON numeric_range */
{
  if (yymsp[0].minor.yy6) {
    // we keep the capitalization as is
    yymsp[0].minor.yy6->nf->fieldName = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
    yylhsminor.yy27 = NewNumericNode(yymsp[0].minor.yy6);
  } else {
    yylhsminor.yy27 = NewQueryNode(QN_NULL);
  }
}
  yymsp[-2].minor.yy27 = yylhsminor.yy27;
        break;
      case 66: /* numeric_range ::= LSQB param_any param_any RSQB */
{
  // Update token type to be more specific if possible
  // and detect syntax errors
  QueryToken *badToken = NULL;
  if (yymsp[-2].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-2].minor.yy0.type = QT_PARAM_NUMERIC_MIN_RANGE;
  else if (yymsp[-2].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-2].minor.yy0;
  if (yymsp[-1].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-1].minor.yy0.type = QT_PARAM_NUMERIC_MAX_RANGE;
  else if (!badToken && yymsp[-1].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-1].minor.yy0;

  if (!badToken) {
    yymsp[-3].minor.yy6 = NewNumericFilterQueryParam_WithParams(ctx, &yymsp[-2].minor.yy0, &yymsp[-1].minor.yy0, yymsp[-2].minor.yy0.inclusive, yymsp[-1].minor.yy0.inclusive);
  } else {
    reportSyntaxError(ctx->status, badToken, "Expecting numeric or parameter");
    yymsp[-3].minor.yy6 = NULL;
  }
}
        break;
      case 67: /* expr ::= modifier COLON geo_filter */
{
  if (yymsp[0].minor.yy6) {
    // we keep the capitalization as is
    yymsp[0].minor.yy6->gf->property = rm_strndup(yymsp[-2].minor.yy0.s, yymsp[-2].minor.yy0.len);
    yylhsminor.yy27 = NewGeofilterNode(yymsp[0].minor.yy6);
  } else {
    yylhsminor.yy27 = NewQueryNode(QN_NULL);
  }
}
  yymsp[-2].minor.yy27 = yylhsminor.yy27;
        break;
      case 68: /* geo_filter ::= LSQB param_any param_any param_any param_any RSQB */
{
  // Update token type to be more specific if possible
  // and detect syntax errors
  QueryToken *badToken = NULL;

  if (yymsp[-4].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-4].minor.yy0.type = QT_PARAM_GEO_COORD;
  else if (yymsp[-4].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-4].minor.yy0;
  if (yymsp[-3].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-3].minor.yy0.type = QT_PARAM_GEO_COORD;
  else if (!badToken && yymsp[-3].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-3].minor.yy0;
  if (yymsp[-2].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-2].minor.yy0.type = QT_PARAM_NUMERIC;
  else if (!badToken && yymsp[-2].minor.yy0.type != QT_NUMERIC)
    badToken = &yymsp[-2].minor.yy0;
  if (yymsp[-1].minor.yy0.type == QT_PARAM_ANY)
    yymsp[-1].minor.yy0.type = QT_PARAM_GEO_UNIT;
  else if (!badToken && yymsp[-1].minor.yy0.type != QT_TERM)
    badToken = &yymsp[-1].minor.yy0;

  if (!badToken) {
    yymsp[-5].minor.yy6 = NewGeoFilterQueryParam_WithParams(ctx, &yymsp[-4].minor.yy0, &yymsp[-3].minor.yy0, &yymsp[-2].minor.yy0, &yymsp[-1].minor.yy0);
  } else {
    reportSyntaxError(ctx->status, badToken, "Syntax error");
    yymsp[-5].minor.yy6 = NULL;
  }
}
        break;
      case 69: /* query ::= expr ARROW LSQB vector_query RSQB */
      case 70: /* query ::= text_expr ARROW LSQB vector_query RSQB */ yytestcase(yyruleno==70);
{ // main parse, hybrid query as entire query case.
  setup_trace(ctx);
  switch (yymsp[-1].minor.yy27->vn.vq->type) {
    case VECSIM_QT_KNN:
      yymsp[-1].minor.yy27->vn.vq->knn.order = BY_SCORE;
      break;
  }
  ctx->root = yymsp[-1].minor.yy27;
  if (yymsp[-4].minor.yy27) {
    QueryNode_AddChild(yymsp[-1].minor.yy27, yymsp[-4].minor.yy27);
  }
}
        break;
      case 71: /* query ::= star ARROW LSQB vector_query RSQB */
{  yy_destructor(yypParser,57,&yymsp[-4].minor);
{ // main parse, simple vecsim search as entire query case.
  setup_trace(ctx);
  switch (yymsp[-1].minor.yy27->vn.vq->type) {
    case VECSIM_QT_KNN:
      yymsp[-1].minor.yy27->vn.vq->knn.order = BY_SCORE;
      break;
  }
  ctx->root = yymsp[-1].minor.yy27;
}
}
        break;
      case 72: /* vector_query ::= vector_command vector_attribute_list vector_score_field */
{
  if (yymsp[-2].minor.yy27->vn.vq->scoreField) {
    rm_free(yymsp[-2].minor.yy27->vn.vq->scoreField);
    yymsp[-2].minor.yy27->vn.vq->scoreField = NULL;
  }
  yymsp[-2].minor.yy27->params = array_grow(yymsp[-2].minor.yy27->params, 1);
  memset(&array_tail(yymsp[-2].minor.yy27->params), 0, sizeof(*yymsp[-2].minor.yy27->params));
  QueryNode_SetParam(ctx, &(array_tail(yymsp[-2].minor.yy27->params)), &(yymsp[-2].minor.yy27->vn.vq->scoreField), NULL, &yymsp[0].minor.yy0);
  yymsp[-2].minor.yy27->vn.vq->params = yymsp[-1].minor.yy86;
  yylhsminor.yy27 = yymsp[-2].minor.yy27;
}
  yymsp[-2].minor.yy27 = yylhsminor.yy27;
        break;
      case 73: /* vector_query ::= vector_command vector_score_field */
{
  if (yymsp[-1].minor.yy27->vn.vq->scoreField) {
    rm_free(yymsp[-1].minor.yy27->vn.vq->scoreField);
    yymsp[-1].minor.yy27->vn.vq->scoreField = NULL;
  }
  yymsp[-1].minor.yy27->params = array_grow(yymsp[-1].minor.yy27->params, 1);
  memset(&array_tail(yymsp[-1].minor.yy27->params), 0, sizeof(*yymsp[-1].minor.yy27->params));
  QueryNode_SetParam(ctx, &(array_tail(yymsp[-1].minor.yy27->params)), &(yymsp[-1].minor.yy27->vn.vq->scoreField), NULL, &yymsp[0].minor.yy0);
  yylhsminor.yy27 = yymsp[-1].minor.yy27;
}
  yymsp[-1].minor.yy27 = yylhsminor.yy27;
        break;
      case 74: /* vector_query ::= vector_command vector_attribute_list */
{
  yymsp[-1].minor.yy27->vn.vq->params = yymsp[0].minor.yy86;
  yylhsminor.yy27 = yymsp[-1].minor.yy27;
}
  yymsp[-1].minor.yy27 = yylhsminor.yy27;
        break;
      case 76: /* vector_score_field ::= as param_term */
{  yy_destructor(yypParser,63,&yymsp[-1].minor);
{
  yymsp[-1].minor.yy0 = yymsp[0].minor.yy0;
}
}
        break;
      case 77: /* vector_score_field ::= as STOPWORD */
{  yy_destructor(yypParser,63,&yymsp[-1].minor);
{
  yymsp[-1].minor.yy0 = yymsp[0].minor.yy0;
  yymsp[-1].minor.yy0.type = QT_TERM;
}
}
        break;
      case 78: /* vector_command ::= TERM param_size modifier ATTRIBUTE */
{
  if (!strncasecmp("KNN", yymsp[-3].minor.yy0.s, yymsp[-3].minor.yy0.len)) {
    yymsp[0].minor.yy0.type = QT_PARAM_VEC;
    yylhsminor.yy27 = NewVectorNode_WithParams(ctx, VECSIM_QT_KNN, &yymsp[-2].minor.yy0, &yymsp[0].minor.yy0);
    yylhsminor.yy27->vn.vq->property = rm_strndup(yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len);
    RedisModule_Assert(-1 != (rm_asprintf(&yylhsminor.yy27->vn.vq->scoreField, "__%.*s_score", yymsp[-1].minor.yy0.len, yymsp[-1].minor.yy0.s)));
  } else {
    reportSyntaxError(ctx->status, &yymsp[-3].minor.yy0, "Syntax error: Expecting Vector Similarity command");
    yylhsminor.yy27 = NULL;
  }
}
  yymsp[-3].minor.yy27 = yylhsminor.yy27;
        break;
      case 79: /* vector_attribute ::= TERM param_term */
{
  const char *value = rm_strndup(yymsp[0].minor.yy0.s, yymsp[0].minor.yy0.len);
  const char *name = rm_strndup(yymsp[-1].minor.yy0.s, yymsp[-1].minor.yy0.len);
  yylhsminor.yy56.param = (VecSimRawParam){ .name = name, .nameLen = yymsp[-1].minor.yy0.len, .value = value, .valLen = yymsp[0].minor.yy0.len };
  if (yymsp[0].minor.yy0.type == QT_PARAM_TERM) {
    yylhsminor.yy56.needResolve = true;
  }
  else { // if yymsp[0].minor.yy0.type == QT_TERM
    yylhsminor.yy56.needResolve = false;
  }
}
  yymsp[-1].minor.yy56 = yylhsminor.yy56;
        break;
      case 80: /* vector_attribute_list ::= vector_attribute_list vector_attribute */
{
  yylhsminor.yy86.params = array_append(yymsp[-1].minor.yy86.params, yymsp[0].minor.yy56.param);
  yylhsminor.yy86.needResolve = array_append(yymsp[-1].minor.yy86.needResolve, yymsp[0].minor.yy56.needResolve);
}
  yymsp[-1].minor.yy86 = yylhsminor.yy86;
        break;
      case 81: /* vector_attribute_list ::= vector_attribute */
{
  yylhsminor.yy86.params = array_new(VecSimRawParam, 1);
  yylhsminor.yy86.needResolve = array_new(bool, 1);
  yylhsminor.yy86.params = array_append(yylhsminor.yy86.params, yymsp[0].minor.yy56.param);
  yylhsminor.yy86.needResolve = array_append(yylhsminor.yy86.needResolve, yymsp[0].minor.yy56.needResolve);
}
  yymsp[0].minor.yy86 = yylhsminor.yy86;
        break;
      case 82: /* num ::= SIZE */
      case 83: /* num ::= NUMBER */ yytestcase(yyruleno==83);
{
  yylhsminor.yy59.num = yymsp[0].minor.yy0.numval;
  yylhsminor.yy59.inclusive = 1;
}
  yymsp[0].minor.yy59 = yylhsminor.yy59;
        break;
      case 84: /* num ::= LP num */
{
  yymsp[-1].minor.yy59=yymsp[0].minor.yy59;
  yymsp[-1].minor.yy59.inclusive = 0;
}
        break;
      case 85: /* num ::= MINUS num */
{
  yymsp[0].minor.yy59.num = -yymsp[0].minor.yy59.num;
  yymsp[-1].minor.yy59 = yymsp[0].minor.yy59;
}
        break;
      case 86: /* term ::= TERM */
      case 87: /* term ::= NUMBER */ yytestcase(yyruleno==87);
      case 88: /* term ::= SIZE */ yytestcase(yyruleno==88);
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 89: /* param_term ::= TERM */
      case 90: /* param_term ::= NUMBER */ yytestcase(yyruleno==90);
      case 91: /* param_term ::= SIZE */ yytestcase(yyruleno==91);
      case 97: /* param_any ::= TERM */ yytestcase(yyruleno==97);
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_TERM;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 92: /* param_term ::= ATTRIBUTE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_PARAM_TERM;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 93: /* param_size ::= SIZE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_SIZE;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 94: /* param_size ::= ATTRIBUTE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_PARAM_SIZE;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 95: /* param_any ::= ATTRIBUTE */
{
  yylhsminor.yy0 = yymsp[0].minor.yy0;
  yylhsminor.yy0.type = QT_PARAM_ANY;
  yylhsminor.yy0.inclusive = 1;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 96: /* param_any ::= LP ATTRIBUTE */
{
  yymsp[-1].minor.yy0 = yymsp[0].minor.yy0;
  yymsp[-1].minor.yy0.type = QT_PARAM_ANY;
  yymsp[-1].minor.yy0.inclusive = 0; // Could be relevant if type is refined
}
        break;
      case 98: /* param_any ::= num */
{
  yylhsminor.yy0.numval = yymsp[0].minor.yy59.num;
  yylhsminor.yy0.inclusive = yymsp[0].minor.yy59.inclusive;
  yylhsminor.yy0.type = QT_NUMERIC;
}
  yymsp[0].minor.yy0 = yylhsminor.yy0;
        break;
      case 100: /* star ::= LP star RP */
{
}
  yy_destructor(yypParser,57,&yymsp[-1].minor);
        break;
      default:
      /* (99) star ::= STAR */ yytestcase(yyruleno==99);
      /* (101) as ::= AS_T */ yytestcase(yyruleno==101);
      /* (102) as ::= AS_S */ yytestcase(yyruleno==102);
        break;
/********** End reduce actions ************************************************/
  };
  assert( yyruleno<sizeof(yyRuleInfoLhs)/sizeof(yyRuleInfoLhs[0]) );
  yygoto = yyRuleInfoLhs[yyruleno];
  yysize = yyRuleInfoNRhs[yyruleno];
  yyact = yy_find_reduce_action(yymsp[yysize].stateno,(YYCODETYPE)yygoto);

  /* There are no SHIFTREDUCE actions on nonterminals because the table
  ** generator has simplified them to pure REDUCE actions. */
  assert( !(yyact>YY_MAX_SHIFT && yyact<=YY_MAX_SHIFTREDUCE) );

  /* It is not possible for a REDUCE to be followed by an error */
  assert( yyact!=YY_ERROR_ACTION );

  yymsp += yysize+1;
  yypParser->yytos = yymsp;
  yymsp->stateno = (YYACTIONTYPE)yyact;
  yymsp->major = (YYCODETYPE)yygoto;
  yyTraceShift(yypParser, yyact, "... then shift");
  return yyact;
}

/*
** The following code executes when the parse fails
*/
#ifndef YYNOERRORRECOVERY
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
){
  RSQueryParser_v2_ARG_FETCH
  RSQueryParser_v2_CTX_FETCH
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yytos>yypParser->yystack ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
/************ Begin %parse_failure code ***************************************/
/************ End %parse_failure code *****************************************/
  RSQueryParser_v2_ARG_STORE /* Suppress warning about unused %extra_argument variable */
  RSQueryParser_v2_CTX_STORE
}
#endif /* YYNOERRORRECOVERY */

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  RSQueryParser_v2_TOKENTYPE yyminor         /* The minor type of the error token */
){
  RSQueryParser_v2_ARG_FETCH
  RSQueryParser_v2_CTX_FETCH
#define TOKEN yyminor
/************ Begin %syntax_error code ****************************************/

  QueryError_SetErrorFmt(ctx->status, QUERY_ESYNTAX,
    "Syntax error at offset %d near %.*s",
    TOKEN.pos, TOKEN.len, TOKEN.s);
/************ End %syntax_error code ******************************************/
  RSQueryParser_v2_ARG_STORE /* Suppress warning about unused %extra_argument variable */
  RSQueryParser_v2_CTX_STORE
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
){
  RSQueryParser_v2_ARG_FETCH
  RSQueryParser_v2_CTX_FETCH
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
#ifndef YYNOERRORRECOVERY
  yypParser->yyerrcnt = -1;
#endif
  assert( yypParser->yytos==yypParser->yystack );
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
/*********** Begin %parse_accept code *****************************************/
/*********** End %parse_accept code *******************************************/
  RSQueryParser_v2_ARG_STORE /* Suppress warning about unused %extra_argument variable */
  RSQueryParser_v2_CTX_STORE
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "RSQueryParser_v2_Alloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void RSQueryParser_v2_(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  RSQueryParser_v2_TOKENTYPE yyminor       /* The value for the token */
  RSQueryParser_v2_ARG_PDECL               /* Optional %extra_argument parameter */
){
  YYMINORTYPE yyminorunion;
  YYACTIONTYPE yyact;   /* The parser action. */
#if !defined(YYERRORSYMBOL) && !defined(YYNOERRORRECOVERY)
  int yyendofinput;     /* True if we are at the end of input */
#endif
#ifdef YYERRORSYMBOL
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
#endif
  yyParser *yypParser = (yyParser*)yyp;  /* The parser */
  RSQueryParser_v2_CTX_FETCH
  RSQueryParser_v2_ARG_STORE

  assert( yypParser->yytos!=0 );
#if !defined(YYERRORSYMBOL) && !defined(YYNOERRORRECOVERY)
  yyendofinput = (yymajor==0);
#endif

  yyact = yypParser->yytos->stateno;
#ifndef NDEBUG
  if( yyTraceFILE ){
    if( yyact < YY_MIN_REDUCE ){
      fprintf(yyTraceFILE,"%sInput '%s' in state %d\n",
              yyTracePrompt,yyTokenName[yymajor],yyact);
    }else{
      fprintf(yyTraceFILE,"%sInput '%s' with pending reduce %d\n",
              yyTracePrompt,yyTokenName[yymajor],yyact-YY_MIN_REDUCE);
    }
  }
#endif

  while(1){ /* Exit by "break" */
    assert( yypParser->yytos>=yypParser->yystack );
    assert( yyact==yypParser->yytos->stateno );
    yyact = yy_find_shift_action((YYCODETYPE)yymajor,yyact);
    if( yyact >= YY_MIN_REDUCE ){
      unsigned int yyruleno = yyact - YY_MIN_REDUCE; /* Reduce by this rule */
#ifndef NDEBUG
      assert( yyruleno<(int)(sizeof(yyRuleName)/sizeof(yyRuleName[0])) );
      if( yyTraceFILE ){
        int yysize = yyRuleInfoNRhs[yyruleno];
        if( yysize ){
          fprintf(yyTraceFILE, "%sReduce %d [%s]%s, pop back to state %d.\n",
            yyTracePrompt,
            yyruleno, yyRuleName[yyruleno],
            yyruleno<YYNRULE_WITH_ACTION ? "" : " without external action",
            yypParser->yytos[yysize].stateno);
        }else{
          fprintf(yyTraceFILE, "%sReduce %d [%s]%s.\n",
            yyTracePrompt, yyruleno, yyRuleName[yyruleno],
            yyruleno<YYNRULE_WITH_ACTION ? "" : " without external action");
        }
      }
#endif /* NDEBUG */

      /* Check that the stack is large enough to grow by a single entry
      ** if the RHS of the rule is empty.  This ensures that there is room
      ** enough on the stack to push the LHS value */
      if( yyRuleInfoNRhs[yyruleno]==0 ){
#ifdef YYTRACKMAXSTACKDEPTH
        if( (int)(yypParser->yytos - yypParser->yystack)>yypParser->yyhwm ){
          yypParser->yyhwm++;
          assert( yypParser->yyhwm ==
                  (int)(yypParser->yytos - yypParser->yystack));
        }
#endif
#if YYSTACKDEPTH>0 
        if( yypParser->yytos>=yypParser->yystackEnd ){
          yyStackOverflow(yypParser);
          break;
        }
#else
        if( yypParser->yytos>=&yypParser->yystack[yypParser->yystksz-1] ){
          if( yyGrowStack(yypParser) ){
            yyStackOverflow(yypParser);
            break;
          }
        }
#endif
      }
      yyact = yy_reduce(yypParser,yyruleno,yymajor,yyminor RSQueryParser_v2_CTX_PARAM);
    }else if( yyact <= YY_MAX_SHIFTREDUCE ){
      yy_shift(yypParser,yyact,(YYCODETYPE)yymajor,yyminor);
#ifndef YYNOERRORRECOVERY
      yypParser->yyerrcnt--;
#endif
      break;
    }else if( yyact==YY_ACCEPT_ACTION ){
      yypParser->yytos--;
      yy_accept(yypParser);
      return;
    }else{
      assert( yyact == YY_ERROR_ACTION );
      yyminorunion.yy0 = yyminor;
#ifdef YYERRORSYMBOL
      int yymx;
#endif
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->yyerrcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminor);
      }
      yymx = yypParser->yytos->major;
      if( yymx==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yypParser, (YYCODETYPE)yymajor, &yyminorunion);
        yymajor = YYNOCODE;
      }else{
        while( yypParser->yytos > yypParser->yystack ){
          yyact = yy_find_reduce_action(yypParser->yytos->stateno,
                                        YYERRORSYMBOL);
          if( yyact<=YY_MAX_SHIFTREDUCE ) break;
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->yytos <= yypParser->yystack || yymajor==0 ){
          yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
          yy_parse_failed(yypParser);
#ifndef YYNOERRORRECOVERY
          yypParser->yyerrcnt = -1;
#endif
          yymajor = YYNOCODE;
        }else if( yymx!=YYERRORSYMBOL ){
          yy_shift(yypParser,yyact,YYERRORSYMBOL,yyminor);
        }
      }
      yypParser->yyerrcnt = 3;
      yyerrorhit = 1;
      if( yymajor==YYNOCODE ) break;
      yyact = yypParser->yytos->stateno;
#elif defined(YYNOERRORRECOVERY)
      /* If the YYNOERRORRECOVERY macro is defined, then do not attempt to
      ** do any kind of error recovery.  Instead, simply invoke the syntax
      ** error routine and continue going as if nothing had happened.
      **
      ** Applications can set this macro (for example inside %include) if
      ** they intend to abandon the parse upon the first syntax error seen.
      */
      yy_syntax_error(yypParser,yymajor, yyminor);
      yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
      break;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->yyerrcnt<=0 ){
        yy_syntax_error(yypParser,yymajor, yyminor);
      }
      yypParser->yyerrcnt = 3;
      yy_destructor(yypParser,(YYCODETYPE)yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser);
#ifndef YYNOERRORRECOVERY
        yypParser->yyerrcnt = -1;
#endif
      }
      break;
#endif
    }
  }
#ifndef NDEBUG
  if( yyTraceFILE ){
    yyStackEntry *i;
    char cDiv = '[';
    fprintf(yyTraceFILE,"%sReturn. Stack=",yyTracePrompt);
    for(i=&yypParser->yystack[1]; i<=yypParser->yytos; i++){
      fprintf(yyTraceFILE,"%c%s", cDiv, yyTokenName[i->major]);
      cDiv = ' ';
    }
    fprintf(yyTraceFILE,"]\n");
  }
#endif
  return;
}

/*
** Return the fallback token corresponding to canonical token iToken, or
** 0 if iToken has no fallback.
*/
int RSQueryParser_v2_Fallback(int iToken){
#ifdef YYFALLBACK
  assert( iToken<(int)(sizeof(yyFallback)/sizeof(yyFallback[0])) );
  return yyFallback[iToken];
#else
  (void)iToken;
  return 0;
#endif
}
